      subroutine geogid(lnods,lnodw,coord,s_tit)
      implicit      real*8 (a-h,o-z)
      include      'Contro.h'
      character*6   s_tit
      dimension     lnods(nnode,nelem), lnodw(12,*), coord(ndime,npoin)

      nnodw = 0
      melem=nelem
c
c...  2D case: all elements can be used
c      
      if (ndime.eq.2) then
        if(nnode.eq.4.and.nelty.eq.2)
     .                 call top004(lnods,nelem,nnode,lnodw,melem,nnodw)
        if(nnode.eq.5) call top05a(lnods,nelem,nnode,lnodw,melem,nnodw)
        if(nnode.eq.7) call top007(lnods,nelem,nnode,lnodw,melem,nnodw)
        if(nnode.eq.3.or.nnodw.eq.3) then
          write(nog,10) s_tit,melem,npoin
        else
          write(nog,20) s_tit,melem,npoin,nnode
        endif
c
c...  3D case: ONLY the P1+ element is split, the rest are unmodified
c      
      else if (ndime.eq.3) then
        if (nnode.eq.5) call top05b(lnods,nelem,nnode,lnodw,melem,nnodw)
        iflag = 3
        write(nog,10) s_tit,melem,npoin
      end if
c
c...  Write coordinates 
c
      do ipoin=1,npoin
        write(nog,30) ipoin,(coord(idime,ipoin),idime=1,ndime)
      enddo
      write(nog,40)
c
c...  Write nodal set for elements
c
      if(nnodw.eq.0) then
        do ielem=1,nelem
          write(nog,50) ielem,(lnods(inode,ielem),inode=1,nnode),7
        end do
      else
        do ielem=1,melem
          write(nog,50) ielem,(lnodw(inode,ielem),inode=1,nnodw),7
        end do
      endif
      close (nog)

   10 format(a6/'version 1.0',4(/),'nelem  npoin',/2i8/,'coordenadas')
   20 format(a6/'version 1.0',4(/),'nelem  npoin  nnode',/3i8/
     .       'coordenadas')
   30 format(4x,i8,3e15.7)
   40 format('conectividades')
   50 format(i8,2x,8i8)
      end 
