      subroutine opfile(
     .  nin,nog,nor,nfo,i_pos,filer,exr,lengtr,s_tit)
      character*4  ext(5), exr
      character*6  s_tit
      character*20 fname(5) , filen(5), filer
      dimension    length(5), len(5)  ,ifext(5)

      nin = 20
      nog = 21
      nor = 22
      nfo = 23
c
c...  Conventions for file extention (if not specified)
c
      ext(1) = '.pos'
      ext(2) = '.fem'
      ext(3) = '.dat'
      ext(4) = '.res'
      ext(5) = '.for'
c
c...  Initialize some variables
c
      do i = 1,5
        length(i) = 0
        len(i)    = 0
        ifext(i)  = 1
      enddo
c
c...  Read name of post-processor
c
      write(6,'(a,$)') 'post-processor: (1) FEMVIEW, (2) GID ? '
      read (5,'(i1)') i_pos
c
c...  Read name of input-file
c
      call f_read(filen(1),len(1),ext(1),fname(1))
c
c...  Calculate length with and without extention
c
      call f_leng(fname(1),length(1),len(1),len(1),ifext(1))
c
c...  Compose filename if necessary
c
      call f_comp(fname(1),filen(1),fname(1),length(1),ext(1),len(1),
     .           ifext(1))
c
c...  Read other filenames, calculate lengths and compose final filenames
c
      if(ngrfo.gt.0) then
        call f_read(filen(1),len(1),ext(5),fname(5))
        call f_leng(fname(5),length(5),len(5),len(1),ifext(5))
        call f_comp(fname(5),filen(5),fname(1),length(5),ext(5),len(5),
     .    ifext(5))
      end if
      if(i_pos.eq.1) then
        call f_read(filen(1),len(1),ext(2),fname(2))
        call f_leng(fname(2),length(2),len(2),len(1),ifext(2))
        call f_comp(fname(2),filen(2),fname(1),length(2),ext(2),len(2),
     .             ifext(2))
        write(6,10) filen(2)(1:6)
        read (5,'(a)') s_tit
        if(s_tit(1:6).eq.'      ') s_tit = filen(2)(1:6)
      else if(i_pos.eq.2) then
        call f_read(filen(1),len(1),ext(3),fname(3))
        call f_read(filen(1),len(1),ext(4),fname(4))
        call f_leng(fname(3),length(3),len(3),len(1),ifext(3))
        call f_leng(fname(4),length(4),len(4),len(1),ifext(4))
        call f_comp(fname(3),filen(3),fname(1),length(3),ext(3),len(3),
     .             ifext(3))
        call f_comp(fname(4),filen(4),fname(1),length(4),ext(4),len(4),
     .             ifext(4))
        write(6,10) filen(3)(1:6)
        read (5,'(a)') s_tit
        if(s_tit(1:6).eq.'      ') s_tit = filen(3)(1:6)
      endif
c
c...  Open files
c
      open(nin,file=filen(1),status='old',form='unformatted')
      if (i_pos.eq.1) then
        open(nog,file=filen(2),status='unknown')
      else if(i_pos.eq.2) then
        filen(3)=filen(3)(1:len(3))//'.gid'//ext(3)
        filen(4)=filen(4)(1:len(4))//'.gid'//ext(4)
        open(nog,file=filen(3),status='unknown')
        open(nor,file=filen(4),status='unknown')
      endif
      if(ngrfo.gt.0) then
        filen(5)=filen(5)(1:len(5))//ext(5)
        open(nfo,file=filen(5),status='unknown')
      end if

      filer  = filen(4)
      exr    = ext(4)
      lengtr = length(4) 

   10 format('title (a6) [default = ',a,']: ',$)
      end
