      subroutine unkfem(istep,ttime,bridge,coord,omega,wopos)
      implicit      real*8 (a-h,o-z)
      include      'Contro.h'
      dimension     bridge(*),coord(ndime,npoin),omega(3)
      character*5   wopos

      ntotv = npoin*ndime
      if (wopos.eq."UNKNO") ntotv=ntotv+ktemp*npoin
      if (wopos.eq."VELOC".or.wopos.eq."UNKNO") then
        call wrvelo(bridge,istep,ttime,wopos)
        if (wopos.eq."UNKNO".and.ktemp.eq.1)
     .    call othfem(istep,ttime,bridge(npoin*ndime+1),"TEMPE")
      else
        call wrvelo(bridge,istep,ttime,'EXT_NORM')
        return
      end if
      unorm=0.0
      do i=1,3
        unorm=unorm+omega(i)*omega(i)
      end do
      if (unorm.gt.1e-4) then
        iposi=0
        if (ndime.eq.2) then
          do ipoin=1,npoin
            bridge(iposi+1)=bridge(iposi+1)-omega(3)*coord(2,ipoin)
            bridge(iposi+2)=bridge(iposi+2)+omega(3)*coord(1,ipoin)
            iposi=iposi+ndime
          end do
        else
          do ipoin=1,npoin
            bridge(iposi+1)=bridge(iposi+1)-omega(3)*coord(2,ipoin)
     .        +omega(2)*coord(3,ipoin)
            bridge(iposi+2)=bridge(iposi+2)+omega(3)*coord(1,ipoin)
     .        -omega(1)*coord(3,ipoin)
            bridge(iposi+3)=bridge(iposi+3)+omega(1)*coord(2,ipoin)
     .        -omega(2)*coord(1,ipoin)
            iposi=iposi+ndime
          end do
        end if
        call wrvelo(bridge,istep,ttime,'ABS_VELO')
      end if

   10 format(1x,i4,a1,a6,e12.5,32x,i2,i5)
   20 format(1x,i2,2x,a8,3i5)
   40 format(1x,i2,2x,a8,2i5)
   60 format(1x,i2,i5,e12.5)
   70 format(1x,i2)
      end
