      subroutine nvsbof(lboty,lboel,elpro,shapb,shaga,shape,
     .                  elvel,elpre,fflow,dsurf,gpcob,baloc,
     .                  cartd,cartb,shapp,grave,elffl)
c**************************************************************************
c
c**** This routine computes the boundary force and torque      
c
c**************************************************************************
      implicit none
      include 'com_prob.f'
      include 'com_auxi.f'
      integer   igaub,inodb
      real*8    visac,tmatr,dummy
      integer   lboty(mboun,nclbo),       lboel(nnodb)
      real*8    elpro(nprod,ngaus),       shapb(nnodb,ngaub),
     .          shaga(ngaus,nnode),       shape(nnodt,ngaus),
     .          cartd(ndime,nnodt,ngaus), elvel(nevab,ncove-iepns), 
     .          elpre(nnods,ncopr-iepns), dsurf(ngaub),             
     .          baloc(ndime,ndime,ngaub), gpcob(ndime,ngaub),
     .          fflow(3,4)
      real*8    cartb(ndime,nnodt),       shapp(nnodt),
     .          grave(ndime,ndime),       elffl(3,4)
c
c*** Main integration loop
c
      igaub=0
      do while(igaub.ne.ngaub)
        igaub=igaub+1
        visac=0.0d0
c
c*** Viscosity. Turbulence effects are supposed to be negligible 
c*** on the boundary
c
        if (kcons.eq.0) then                                ! Constant prop.
          visac=visco(1)
        else
          do inodb=1,nnodb 
            do igaus=1,ngaus
              tmatr=shaga(igaus,lboel(inodb))
     .          *shapb(inodb,igaub)
              visac=visac+elpro(2,igaus)*tmatr
            end do
          end do
        end if
c
c*** Compute the boundary force and torque
c
        if(lboty(iboun,2).eq.1) then
          call nvscar(lboel,shapb(1,igaub),   shaga,  
     .                cartd,shape,dummy,shapp,cartb,  
     .                dummy,ndime,nnodb,nnode,nnods,  
     .                nnodt,ngaus,    0,    0)
          call nvsfor(baloc(1,ndime,igaub),dsurf(igaub),    ! Force and torque
     .                gpcob(1,igaub),shapp,cartb,elvel,
     .                elpre,elffl,grave,visac,ndime,nnode,
     .                nnods,nnodt,fflow)
          sflow=sflow+dsurf(igaub)                          ! Comput. surface
        else
          igaub=ngaub
        end if
      end do

      end
