      subroutine tembou(lboel,shapb,tload,ivabo,elmat,elrhs,eltem,
     .                  dsurf,tpara)
c*********************************************************************
c
c**** This routine computes the element matrix and RHS for the tempe-
c**** rature equation due to the contribution of the boundaries 
c
c*********************************************************************
      implicit real*8(a-h,o-z)
      include 'com_prob.f'
      include 'com_auxi.f'
      integer   lboel(nnodb),               ivabo(ntloa,nboun)
      real*8    shapb(nnodb,ngaub),         tload(ntloa,nboun,ncotl),
     .          eltem(nnode),               elmat(nnode,nnode),
     .          elrhs(nnode),               dsurf(ngaub)
      real*8    tpara(3,2)
c
c*** Main integration loop
c
      do igaus=1,ngaub
        call heasuq(lboel,shapb(1,igaus),tload,ivabo,       ! Compute TRACT, 
     .              lfutn,pneum,eltem,tpara,oltem,          ! containing the 
     .              nnodb,nnode,ntloa,nboun,ncotl,          ! heat flux
     .              nmpan,mfpan,iepns,iethe,tactu,
     .              tstep,iiter,iboun,ndime)
        xmrhs=tstep*dsurf(igaus)*
     .    (tpara(1,2)*(1.0-thhe1)*(oltem-tpara(2,2))-
     .     tpara(1,1)*     thhe1 *       tpara(2,1) +
     .     thhe1*tpara(3,1)+(1.0-thhe1)*tpara(3,2))
        xmmat=thhe1*dsurf(igaus)*tstep*tpara(1,1)
        do inodb=1,nnodb                                    ! Compute the 
          inode=lboel(inodb)                                ! element matrxi & RHS
          elrhs(inode)=elrhs(inode)
     .      +shapb(inodb,igaus)*xmrhs
          xmuit=xmmat*shapb(inodb,igaus)
          if(kfait.eq.1) then
            do jnodb=1,nnodb
              jnode=lboel(jnodb)
              elmat(inode,jnode)=elmat(inode,jnode)-
     .          xmuit*shapb(jnodb,igaus)
            end do
          end if
        end do
      end do

      end
