      subroutine mcnepo(p_lelpo,nepoi,lnods,nelem,nnode,node0,
     .                  node1  ,npoii,lenpo)
c**********************************************************************
c                 
c**** This routine computes the number of elements to which the nodal
c**** points belong and allocates memory for the list 
c                 
c**********************************************************************
      implicit none
      integer nelem,nnode,npoii,ielem,inode,ipoin,lbyts,
     .        lenpo,nlist,node0,node1
      integer nepoi(npoii), lnods(nnode,nelem)
      integer p_lelpo,p_ele                                 ! pointer
c
c*** Number of elements per nodal point
c
      call lvecze(npoii,nepoi)
      do ielem=1,nelem
        do inode=1,nnode
          ipoin=lnods(inode,ielem)
          nepoi(ipoin)=nepoi(ipoin)+1
        end do
      end do
c
c*** Allocate memory for the list of elements (only when the node is
c*** connected to more than one element)      
c
      do ipoin=1,npoii
        nlist=nepoi(ipoin)
        if(nlist.gt.1) then
          lbyts=lenpo*nlist
          call admemo(0,p_ele,lbyts)
          call poiass(p_ele,%val(p_lelpo+(ipoin-1)*lenpo))
          call lvecze(nepoi(ipoin),%val(p_ele))
        end if
      end do

      end
