      subroutine sttohi(glvec,lnods,ndimv,npoin,nnode,nelem,nnodt,
     .                  nelty,ndime,iwork)
c*****************************************************************
c
c**** This routine pass standar glvec to hierarchic
c            2D :
c                 TRIANGLES     : 4 , 6 & 7 nodes
c                 QUADRILATERAL : 5 , 8 & 9 nodes
c
c            3D :
c                 TETRAHEDRA    : 5 , 10 & 11 nodes
c                 HEXAHEDRA     : 9           nodes
c
c*****************************************************************
      implicit real*8(a-h,o-z)
      real*8    glvec(ndimv,npoin)
      integer   lnods(nnodt,nelem),    iwork(npoin)
      call lvecze (npoin,iwork)
      do ielem=1,nelem
        if (nelty.eq.2 .and. nnode.eq.4 ) then
          ipoin=lnods(4,ielem)
          do idimv=1,ndimv
            do inode=1,3
              glvec(idimv,ipoin)=glvec(idimv,ipoin)-
     .          1./3.*glvec(idimv,lnods(inode,ielem))
            end do
          end do
        else if (nelty.eq.2 .and. (nnode.eq.6 .or. nnode.eq.7)) then
          ipoin=lnods(4,ielem)
          if (iwork(ipoin).ne.1) then
            do idimv=1,ndimv
              do inode=1,2
                glvec(idimv,ipoin)=glvec(idimv,ipoin)-
     .            .5*glvec(idimv,lnods(inode,ielem))
              end do
            end do
            iwork(ipoin)=1
          end if
          ipoin=lnods(5,ielem)
          if (iwork(ipoin).ne.1) then
            do idimv=1,ndimv
              do inode=2,3
                glvec(idimv,ipoin)=glvec(idimv,ipoin)-
     .            .5*glvec(idimv,lnods(inode,ielem))
              end do
            end do
            iwork(ipoin)=1
          end if
          ipoin=lnods(6,ielem)
          if (iwork(ipoin).ne.1) then
            do idimv=1,ndimv
              do inode=1,3,2
                glvec(idimv,ipoin)=glvec(idimv,ipoin)-
     .            .5*glvec(idimv,lnods(inode,ielem))
              end do
            end do
            iwork(ipoin)=1
          end if
          if (nnode.eq.7) then
            ipoin=lnods(7,ielem)
            do idimv=1,ndimv
              do inode=1,3
                glvec(idimv,ipoin)=glvec(idimv,ipoin)-
     .            1./3.*glvec(idimv,lnods(inode,ielem))-
     .            4./9.*glvec(idimv,lnods(inode+3,ielem))
              end do
            end do
          end if
        else if (nelty.eq.1 .and. nnode.eq.5 ) then
          ipoin=lnods(5,ielem)
          do idimv=1,ndimv
            do inode=1,4
              glvec(idimv,ipoin)=glvec(idimv,ipoin)-
     .          .25*glvec(idimv,lnods(inode,ielem))
            end do
          end do
        else if (nelty.eq.1 .and. ndime.eq.2 .and.
     .      (nnode.eq.8 .or. nnode.eq.9)) then
          ipoin=lnods(5,ielem)
          if (iwork(ipoin).ne.1) then
            do idimv=1,ndimv
              do inode=1,2
                glvec(idimv,ipoin)=glvec(idimv,ipoin)-
     .            .5*glvec(idimv,lnods(inode,ielem))
              end do
            end do
            iwork(ipoin)=1
          end if
          ipoin=lnods(6,ielem)
          if (iwork(ipoin).ne.1) then
            do idimv=1,ndimv
              do inode=2,3
                glvec(idimv,ipoin)=glvec(idimv,ipoin)-
     .            .5*glvec(idimv,lnods(inode,ielem))
              end do
            end do
            iwork(ipoin)=1
          end if
          ipoin=lnods(7,ielem)
          if (iwork(ipoin).ne.1) then
            do idimv=1,ndimv
              do inode=3,4
                glvec(idimv,ipoin)=glvec(idimv,ipoin)-
     .            .5*glvec(idimv,lnods(inode,ielem))
              end do
            end do
            iwork(ipoin)=1
          end if
          ipoin=lnods(8,ielem)
          if (iwork(ipoin).ne.1) then
            do idimv=1,ndimv
              do inode=1,4,3
                glvec(idimv,ipoin)=glvec(idimv,ipoin)-
     .            .5*glvec(idimv,lnods(inode,ielem))
              end do
            end do
            iwork(ipoin)=1
          end if
          if (nnode.eq.9) then
            ipoin=lnods(9,ielem)
            do idimv=1,ndimv
              do inode=1,4
                glvec(idimv,ipoin)=glvec(idimv,ipoin)-
     .            .25*glvec(idimv,lnods(inode,ielem))-
     .            .5*glvec(idimv,lnods(inode+4,ielem))
              end do
            end do
          end if
        end if
        if (nelty.eq.2 .and. nnode.eq.5 ) then
          ipoin=lnods(5,ielem)
          do idimv=1,ndimv
            do inode=1,4
              glvec(idimv,ipoin)=glvec(idimv,ipoin)-
     .          .25*glvec(idimv,lnods(inode,ielem))
            end do
          end do
        else if (nelty.eq.2 .and. (nnode.eq.10.or.nnode.eq.11)) then
          ipoin=lnods(5,ielem)
          if (iwork(ipoin).ne.1) then
            do idimv=1,ndimv
              do inode=1,2
                glvec(idimv,ipoin)=glvec(idimv,ipoin)-
     .            .5*glvec(idimv,lnods(inode,ielem))
              end do
            end do
          end if
          ipoin=lnods(6,ielem)
          if (iwork(ipoin).ne.1) then
            do idimv=1,ndimv
              do inode=2,3
                glvec(idimv,ipoin)=glvec(idimv,ipoin)-
     .            .5*glvec(idimv,lnods(inode,ielem))
              end do
            end do
          end if
          ipoin=lnods(7,ielem)
          if (iwork(ipoin).ne.1) then
            do idimv=1,ndimv
              do inode=1,3,2
                glvec(idimv,ipoin)=glvec(idimv,ipoin)-
     .            .5*glvec(idimv,lnods(inode,ielem))
              end do
            end do
          end if
          ipoin=lnods(8,ielem)
          if (iwork(ipoin).ne.1) then
            do idimv=1,ndimv
              do inode=1,4,3
                glvec(idimv,ipoin)=glvec(idimv,ipoin)-
     .            .5*glvec(idimv,lnods(inode,ielem))
              end do
            end do
          end if
          ipoin=lnods(9,ielem)
          if (iwork(ipoin).ne.1) then
            do idimv=1,ndimv
              do inode=2,4,2
                glvec(idimv,ipoin)=glvec(idimv,ipoin)-
     .            .5*glvec(idimv,lnods(inode,ielem))
              end do
            end do
          end if
          ipoin=lnods(10,ielem)
          if (iwork(ipoin).ne.1) then
            do idimv=1,ndimv
              do inode=3,4
                glvec(idimv,ipoin)=glvec(idimv,ipoin)-
     .            .5*glvec(idimv,lnods(inode,ielem))
              end do
            end do
          end if
          if (nnode.eq.11) then
            ipoin=lnods(11,ielem)
            do idimv=1,ndimv
              do inode=1,10
                glvec(idimv,ipoin)=glvec(idimv,ipoin)-
     .            .25*glvec(idimv,lnods(inode,ielem))
              end do
            end do
          end if
        else if (ndime.eq.3 .and. nelty.eq.1 .and. nnode.eq.9) then
          ipoin=lnods(9,ielem)
          do idimv=1,ndimv
            do inode=1,8
              glvec(idimv,ipoin)=glvec(idimv,ipoin)-
     .          .125*glvec(idimv,lnods(inode,ielem))
            end do
          end do
        end if
      end do ! do ielem=1,nelem
      
      end
