      subroutine mbvab1(a,b,c,n1,n2,en1,en2)
c********************************************************************
c
c**** This routine evaluates the matrix-vector product A = B C, where
c**** A -> R(n1), B -> Mat(n1,n2), C -> R(n2), and also computes  the
c**** Euclidian norms of A and C
c
c********************************************************************
      implicit real*8(a-h,o-z)
      real*8 a(n1), b(n1,n2), c(n2)

      do i=1,n1
        a(i)=0.0
        do k=1,n2
          a(i)=a(i)+b(i,k)*c(k)
        end do
      end do

      en1=0.0
      en2=0.0
      do i=1,n1
        en1=en1+a(i)*a(i)
      end do
      do i=1,n2
        en2=en2+c(i)*c(i)
      end do
      en1=sqrt(en1)
      en2=sqrt(en2)

      end


