      subroutine mbvab2(a,b,c,n1,n2)
c***********************************************************************
c
c**** This routine evaluates the matrix-vector product A = B^t C, where
c**** A -> R(n1), B -> Mat(n2,n1), C -> R(n2)
c
c***********************************************************************
      implicit none
      integer  n1,n2,i,k
      real*8   a(n1), b(n2,n1), c(n2)

      do i=1,n1
        a(i)=0.0
        do k=1,n2
          a(i)=a(i)+b(k,i)*c(k)
        end do
      end do

      end
