      subroutine vecmix(v1,v2,v3,det)
c*****************************************************************************
c
c**** This routine computes the determinant of the matrix made up with
c**** three vectors (mixed product)      
c
c*****************************************************************************
      implicit none
      real*8  v1(3),v2(3),v3(3),det,t1,t2,t3

      t1  = v2(2)*v3(3) - v3(2)*v2(3)
      t2  =-v2(1)*v3(3) + v3(1)*v2(3)
      t3  = v2(1)*v3(2) - v3(1)*v2(2)
      det = v1(1)*t1 + v1(2)*t2 + v1(3)*t3

      end
