      subroutine vecnor(v,n,vnor,inor)
c*****************************************************************************
c
c**** Computes the L1, L2 and L-inf norms of a vector V of length N
c
c*****************************************************************************
      implicit none
      integer    i,n, inor
      real*8     v(n)
      real*8     vnor

      if(inor.eq.0.or.inor.eq.3) then
        vnor=0.0
        do i=1,n
          if(abs(v(i)).gt.vnor) vnor=abs(v(i))
        end do
      else if(inor.eq.1) then
        vnor=0.0
        do i=1,n
          vnor=vnor+abs(v(i))
        end do
      else if(inor.eq.2) then
        vnor=0.0
        do i=1,n
          vnor=vnor+v(i)*v(i)
        end do
        vnor=sqrt(vnor)
      end if

      end
