      subroutine vecpro(v1,v2,v3)
c*****************************************************************************
c
c**** Three-dimensional vectorial product of two vectors  v3 = v1 x v2.
c**** The same pointer as for v1 or v2 may be used for v3
c
c*****************************************************************************
      implicit none
      real*8   v1(3),v2(3),v3(3)
      real*8   c1,c2,c3

      c1=v1(2)*v2(3)-v1(3)*v2(2)
      c2=v1(3)*v2(1)-v1(1)*v2(3)
      c3=v1(1)*v2(2)-v1(2)*v2(1)
      v3(1)=c1
      v3(2)=c2
      v3(3)=c3

      end
