      program fantom    ! version 1.0                     01/july/1993
c**********************************************************************
c*                                                                    *
c*          ##################################################        *
c*          #                                                #        *
c*          #                    OOOOOO                      #        *
c*          #                  OO      OO                    #        *
c*          #                 OO  O  O  OO                   #        *
c*          #                 OO        OO                   #        *
c*          #                  OO      OO                    #        *
c*          #                  OO      OO                    #        *
c*          #                  OO      OO                    #        *
c*          #                                                #        *
c*          #                                                #        *
c*          #      Flow Analysis Numerical Techniques        #        *
c*          #               Organized Moduli                 #        *
c*          #                                                #        *
c*          ##################################################        *
c*                                                                    *
c*                                                                    *
c*         Finite element program for the numerical simualtion        *
c*                    of incompressible flow problems                 *
c*                                                                    *
c*                             Written by                             *
c*                                                                    *
c*                     Ramon CODINA and Orlando SOTO                  *
c*                                                                    *
c*                                                                    *
c**********************************************************************
      implicit none
      include 'com_auxi.f'

      call fildef                ! file definition
      call runkey                ! start the run
      call readpd                ! read problem data
      call warerr                ! writes warnings & errors
      call cderda                ! set rest of parameters
      call addpri                ! set up permanent memory pointers
      call addwor                ! set up temporary memory pointers 
      call moduls(%val(iadpr),   ! start computation
     .  %val(iadwo))

      end
