      subroutine addwor
c**********************************************************************
c
c*** This routine calculates the pointers for temporary arrays
c*** and allocates memory for permanent & temporary arrays
c
c**********************************************************************
      include 'com_prob.f'
      include 'com_auxi.f'
      integer  lnavs

      lwor1=nelem*nsube*(ndime+1)*(ndime+1)        ! lface(ndime+1,nface) 
c
c*** Access to the element library
c
      iacel( 1)=1                                  ! elcod(ndime,nnode)
      iacel( 2)=iacel( 1)+ndime*nnode              ! elvel(nevab,ncove-iepns)
      iacel( 3)=iacel( 2)+nevab*(ncove-iepns)      ! elpre(nnods,ncopr-iepns)
      iacel( 4)=iacel( 3)+nnods*(ncopr-iepns)      ! eltem(nnode,ncote-iephe)
      iacel( 5)=iacel( 4)+nnode*(ncote-iephe)      ! elfrs(nnode,ncofs-iepfs)
      iacel( 6)=iacel( 5)+nnode*(ncofs-iepfs)      ! elmat(mvalo,mvalo)
      iacel( 7)=iacel( 6)+mvalo*mvalo              ! elrhs(mvalo,mcrhs)      
      iacel( 8)=iacel( 7)+mcrhs*mvalo              ! elspa(nnode,6)
      iacel( 9)=iacel( 8)+nnode*6                  ! 
      lacel    =iacel( 9)+2*(nnode**4)+nnodt       ! work used in ELMACC
      if (lacel.gt.lwor1) lwor1=lacel              ! Always needed
c
c*** Access to the boundary library
c
      iacbo( 1)=1                                   ! bocod(ndime,nnodb)
      iacbo( 2)=iacbo( 1)+ndime*nnodb               ! bovel(ndime*nnodb,n-iu..)
      iacbo( 3)=iacbo( 2)+ndime*nnodb*(ncove-iupns) ! bopre(nnodb,ncopr-iepns)
      iacbo( 4)=iacbo( 3)+nnodb*(ncopr-iepns)       ! botem(nnodb,ncote-iuphe)
      iacbo( 5)=iacbo( 4)+nnodb*(ncote-iuphe)       ! bofrs(nnodb,ncofs-iupfs)
      iacbo( 6)=iacbo( 5)+nnodb*(ncofs-iupfs)       ! bomat(mvalo,mvalo)
      iacbo( 7)=iacbo( 6)+mvalo*mvalo               ! borhs(mvalo,mcrhs)
      iacbo( 8)=iacbo( 7)+mcrhs*mvalo               ! elpre(nnods,ncopr-iepns)
      iacbo( 9)=iacbo( 8)+nnods*(ncopr-iepns)
      lacbo    =iacbo( 9)
      if(lacbo.gt.lwor1) lwor1=lacbo
c
c*** Routine splobj
c
      isetm( 1)=1                                  ! deriv(ndime,nnodt,ngaus)
      isetm( 2)=isetm( 1)+ndime*nnodt*ngaus        ! heslo(ntens,nnodt,ngaus)
      isetm( 3)=isetm( 2)+ntens*nnodt*ngaus        ! posgp(ndime,ngaus)
      isetm( 4)=isetm( 3)+ndime*ngaus              ! weigp(ngaus)
      isetm( 5)=isetm( 4)+ngaus                    ! xjaci(ndime,ndime)
      isetm( 6)=isetm( 5)+ndime*ndime              ! xjacm(ndime,ndime)
      isetm( 7)=isetm( 6)+ndime*ndime              ! wmat1(ndime,ndime,nnode)
      isetm( 8)=isetm( 7)+ndime*ndime*nnode        ! wmat2(ndime,ndime,nnode)
      isetm( 9)=isetm( 8)+ndime*ndime*nnode        ! d2sdx(ndime,ndime,ndime)
      isetm(10)=isetm( 9)+ndime*ndime*ndime        ! shapw(nnode)
      isetm(11)=isetm(10)+nnode                    ! deriw(ndime,nnode)
      isetm(12)=isetm(11)+ndime*nnode              ! cartw(ndime,nnode)
      isetm(13)=isetm(12)+ndime*nnode              ! elcod(ndime,nnode)
      isetm(14)=isetm(13)+ndime*nnode              ! exwor(ndime,npoin)
      isetm(15)=isetm(14)+ndime*npoin              ! bocod(ndime,nnodb)
      isetm(16)=isetm(15)+ndime*nnodb              ! derib(ndimb,nnodb,ngaub)
      isetm(17)=isetm(16)+ndimb*nnodb*ngaub        ! posgb(ndimb,ngaub)
      isetm(18)=isetm(17)+ndimb*ngaub              ! weigb(ngaub)
      isetm(19)=isetm(18)+ngaub                    
      lsetm    =isetm(19)
      if(lsetm.gt.lwor1) lwor1=lsetm
c
c*** Routine proelm
c
      iproe( 1)=1                                  ! grave(ndime,ndime)
      iproe( 2)=iproe( 1)+ndime*ndime              ! tvelo(ndime)
      iproe( 3)=iproe( 2)+ndime
      lproe    =iproe( 3)
      if(lproe.gt.lwor1) lwor1=lproe
c
c*** Routine preelm
c
      ipree( 1)=1                                  ! premm(nnods,nnods)
      ipree( 2)=ipree( 1)+nnods*nnods              ! premi(nnods,nnods)
      ipree( 3)=ipree( 2)+nnods*nnods              ! gtuve(nnods)
      ipree( 4)=ipree( 3)+nnods                    ! princ(nnods)
      ipree( 5)=ipree( 4)+nnods                    ! gtugl(ntotp*inpco)
      ipree( 6)=ipree( 5)+inpco*ntotp
      lpree    =ipree( 6)
      if(lpree.gt.lwor1) lwor1=lpree      
c
c*** Routine nvselm
c
      invse( 1)=1                                  ! wmatr(nevat,nevat)
      invse( 2)=invse( 1)+nevat*nevat              ! wrhsi(nevat)
      invse( 3)=invse( 2)+nevat                    ! rmom1(ndime,nevab)
      invse( 4)=invse( 3)+ndime*nevab              ! rmom2(ndime,nevab)
      invse( 5)=invse( 4)+ndime*nevab              ! rmom3(nevab)
      invse( 6)=invse( 5)+nevab                    ! rpre1(ndime,nnods)
      invse( 7)=invse( 6)+ndime*nnods              ! rdimo(nevab)
      invse( 8)=invse( 7)+nevab                    ! rlapr(nnods)
      invse( 9)=invse( 8)+nnods*ldimo              ! bmome(ndime)
      invse(10)=invse( 9)+ndime                    ! elext(ndime,2)
      invse(11)=invse(10)+ndime*2                  ! ptesm(nevab,ndime)
      invse(12)=invse(11)+nevab*ndime              ! ptesd(nevab)
      invse(13)=invse(12)+nevab                    ! ptesi(nnods,ndime)
      invse(14)=invse(13)+nnods*ndime              ! ptedm(nevab)
      invse(15)=invse(14)+nevab                    ! ptelq(nnods)
      invse(16)=invse(15)+nnods*ldimo              ! vegau(ndime,ncove)
      invse(17)=invse(16)+ndime*ncove              ! grave(ndime,ndime,2)
      invse(18)=invse(17)+ndime*ndime*2            ! waxis(nnode*naxis)
      invse(19)=invse(18)+nnode*naxis              ! wvect(ndime*ndime)
      invse(20)=invse(19)+ndime*ndime              ! alapl(nnode*klsns)
      invse(21)=invse(20)+nnode*klsns              ! chave(ndime,2)
      invse(22)=invse(21)+ndime*2                  ! chavg(ndime,ndime)
      invse(23)=invse(22)+ndime*ndime*ldimo        ! hesma(ndime,ndime,nnode)
      invse(24)=invse(23)+ndime*ndime*nnode*       ! reyst(ndime,ndime)
     .                    ldimo*iecns*neres
      lnvse    =invse(24)+ndime*ndime
      if(lnvse.gt.lwor1) lwor1=lnvse
c
c*** Routine kinelm, epselm and kepelm (maximum dimensions)
c
      ikine( 1)=1                                  ! wmatr(2*nnode,2*nnode)
      ikine( 2)=ikine( 1)+4*nnode*nnode            ! wrhsi(2*nnode)
      ikine( 3)=ikine( 2)+2*nnode                  ! vgran(nnode)
      ikine( 4)=ikine( 3)+nnode                    ! grkea(ndime,2)
      ikine( 5)=ikine( 4)+2*ndime                  ! vegau(ndime,2)
      ikine( 6)=ikine( 5)+2*ndime                  ! grave(ndime,ndime)
      ikine( 7)=ikine( 6)+ndime*ndime              ! grkac(ndime,2)
      ikine( 8)=ikine( 7)+2*ndime
      lkine    =ikine( 8)
      if (lkine.gt.lwor1) lwor1=lkine
c
c*** Routine nvsbou, nvsbof and nvsatm
c
      invsb( 1)=1                                  ! tract(ndime)
      invsb( 2)=invsb( 1)+ndime                    ! veloc(ndime,2)
      invsb( 3)=invsb( 2)+ndime*2                  ! tvelo(ndime)
      invsb( 4)=invsb( 3)+ndime                    ! cartb(ndime,nnodt)
      invsb( 5)=invsb( 4)+ndime*nnodt              ! shapp(nnodt)
      invsb( 6)=invsb( 5)+nnodt                    ! grave(ndime,ndime,2)
      invsb( 7)=invsb( 6)+ndime*ndime*2            ! hessb(ntens,nnode)
      invsb( 8)=invsb( 7)+ntens*nnode              ! centf( 3)
      invsb( 9)=invsb( 8)+3                        ! elffl(12)
      invsb(10)=invsb( 9)+12                       ! exnor(ndime,nnodb)
      invsb(11)=invsb(10)+ndime*nnodb              ! posgb(ndimb,nnodb)
      invsb(12)=invsb(11)+ndimb*nnodb              ! weigb(nnodb)
      invsb(13)=invsb(12)+nnodb                    ! shaga(ngaub,nnodb)
      invsb(14)=invsb(13)+ngaub*nnodb              ! wmatr(nevat,nevat)
      invsb(15)=invsb(14)+nevat*nevat              ! wrhsi(nevat)
      invsb(16)=invsb(15)+nevat
      lnvsb    =invsb(16)
      if(lnvsb.gt.lwor1) lwor1=lnvsb
c
c*** Routine temelm
c
      iteme( 1)=1                                  ! wmatr(nnode,nnode)
      iteme( 2)=iteme( 1)+nnode*nnode              ! wrhsi(nnode)
      iteme( 3)=iteme( 2)+nnode                    ! rtem1(nnode)
      iteme( 4)=iteme( 3)+nnode                    ! rtem2(nnode)
      iteme( 5)=iteme( 4)+nnode                    ! ptest(nnode)
      iteme( 6)=iteme( 5)+nnode                    ! chave(ndime,2)
      iteme( 7)=iteme( 6)+ndime*2                  ! velas(ndime)
      iteme( 8)=iteme( 7)+ndime                    ! veold(ndime)
      iteme( 9)=iteme( 8)+ndime                    ! grate(ndime)
      iteme(10)=iteme( 9)+ndime                    ! alapl(nnode)
      iteme(11)=iteme(10)+nnode
      lteme    =iteme(11)
      if(lteme.gt.lwor1) lwor1=lteme
c
c*** Routine tembou
c
      itemb( 1)=1                                  ! tpara(ntloa-ndime*iepns,2)
      itemb( 2)=itemb( 1)+(ntloa-ndime*iepns)*2
      ltemb    =itemb( 2)
      if(ltemb.gt.lwor1) lwor1=ltemb
c
c*** Routine pscelm
c
      ipsce( 1)=1                                  ! grpsc(ndime)
      ipsce( 2)=ipsce( 1)+ndime                    ! veloc(ndime)
      ipsce( 3)=ipsce( 2)+ndime                    ! chave(ndime,2)
      ipsce( 4)=ipsce( 3)+ndime*2                  ! ptest(nnode)
      ipsce( 5)=ipsce( 4)+nnode
      lpsce    =ipsce( 5)
      if(lpsce.gt.lwor1) lwor1=lpsce
c
c*** Routine redpsc
c
      irepc( 1)=1                                 ! dista(npoin)
      irepc( 2)=irepc( 1)+npoin                   ! coint(ndime,ndime+1)
      irepc( 3)=irepc( 2)+ndime*(ndime+1)         ! xinte(ndime)
      irepc( 4)=irepc( 3)+ndime                   ! vxver(ndime,ndime)
      irepc( 5)=irepc( 4)+ndime*ndime
      lrepc    =irepc( 5)
      if(lrepc.gt.lwor1) lwor1=lrepc
c
c*** Routine output 
c
      ismoe( 1)=lacel                             ! rhsmo(npoin,ntens+6)
      ismoe( 2)=ismoe( 1)+npoin*(ntens+6)         ! iwork(npoin)
      ismoe( 3)=ismoe( 2)+npoin                   ! posgn(ndime,nnode)
      ismoe( 4)=ismoe( 3)+ndime*nnode             ! weign(nnode)
      ismoe( 5)=ismoe( 4)+nnode                   ! shapn(nnodt)
      ismoe( 6)=ismoe( 5)+nnodt                   ! derin(ndime,nnodt)
      ismoe( 7)=ismoe( 6)+ndime*nnodt             ! cartn(ndime,nnode)
      ismoe( 8)=ismoe( 7)+ndime*nnode             ! grave(ndime,ndime)
      ismoe( 9)=ismoe( 8)+ndime*ndime             ! xjacn(ndime*ndime)
      ismoe(10)=ismoe( 9)+ndime*ndime             ! stres(ndime,ndime)
      ismoe(11)=ismoe(10)+ndime*ndime             ! teunk(npoin)
      ismoe(12)=ismoe(11)+npoin
      lsmoe    =ismoe(12)
      if(lsmoe.gt.lwor1) lwor1=lsmoe
c
c*** Routine turre0
c
      iturr( 1)=1                                 ! elvel(ndime,nnode)
      iturr( 2)=iturr( 1)+ndime*nnode             ! grave(ndime,ndime)
      iturr( 3)=iturr( 2)+ndime*ndime             ! reyst(ndime,ndime)
      iturr( 4)=iturr( 3)+ndime*ndime             ! elkin(nnode)
      iturr( 5)=iturr( 4)+nnode                   ! elene(nnode)
      iturr( 6)=iturr( 5)+nnode                   ! ellon(nnode)
      iturr( 7)=iturr( 6)+nnode                   ! elvit(nnode)
      iturr( 8)=iturr( 7)+nnode                   ! p_ten(ndime,ndime)
      iturr( 9)=iturr( 8)+ndime*ndime             ! iwork(2*nnode)
      lturr    =iturr( 9)+2*nnode
      if(lturr.gt.lwor1) lwor1=lturr
c
c*** Miscellaneous bounds for WORK1
c
      lnavs=ntovp+(nnodt*nelem+1)*lenpo/8
      lwor1=max(lwor1,lnavs)                      ! VELOC,PRESU,LNODS (NAVSTO)
      lwor1=max(lwor1,3*npoin)                    ! ITUFI,TKINE,TENER (TUKIEP)
      lwor1=max(lwor1,(nnodt*nelem*lenpo+4)/8)    ! LNODS (renumber in NS)
      lwor1=max(lwor1,ndime*(npoin+nnods*nelem))  ! TEMCO (in TAHOOD)
      lwor1=max(lwor1,3*npoin+ndime*ndime*ngaus   ! WORK1 (in TURWA1)
     .                +ndime*ndime)
      lwor1=max(lwor1,((nnodt*nelem+2*npoin)      ! LNODS & ITUFI (RENEQU)
     .  *lenpo+4)/8)                               

c
c*** Allocate permanent+temporary memory
c
      lwor1=lwor1+lacel-1
      ltotl=lprin+lwor1
      lbyts=lwor1*8
      call admemo(0,iadwo,lbyts)
      call veczer(lwor1,%val(iadwo))

      end
