      subroutine blodat
c***********************************************************************
c
c*** This routine contains the default values for some data (block data)
c
c***********************************************************************
      implicit none
      include 'com_prob.f'
      include 'com_auxi.f'
c
c*** Variables belonging to COM_PROB
c      
      data nelty,ndime,naxis,nbcon/
     .         1,    2,    0,    0/
      data inint,inqua,insmo,igopo,inpin,inpco,inpes,lsnsc,
     .     lsnsv,lsnsp,lsnsr,ldimo,lsnsb,neuns,ilins,npica,
     .     inons,micns,iasns,mians,imsns,irsns,lshec,lshed,
     .     neuhe,inohe,miche,iashe,miahe,imshe,irshe,itefs,
     .     lspcc,neupc,inopc,micpc,ismpc,iaspc,miapc,imspc,
     .     irspc,kscns,ksche,itwns,itwhe,itwfs,kryns,kryhe,
     .     krypc,itwtu,ksctu,ilitu,npitu,micou,micin,iastu,
     .     imstu,irstu,miatu,krytu,nkwit,tucou,nsctu,twost,
     .     ip1p1,kwall,lfins,lfitu,lfihe,lfipc,lfuto,lfuta,
     .     nturf,nituf/      
     .         0,    0,    2,    1,    0,    0,    0,    0,
     .         0,    0,    0,    0,    0,  100,    1,  100,  
     .         2,    1,   11,  100,    0,    1,    0,    0,
     .       100,    2,    1,   11,  100,    0,    1,    1,
     .         0,  100,    2,    1,    0,   11,  100,    0,
     .         1,    0,    0,    0,    0,    0,    0,    0,
     .         0,    0,    0,    1,    1,  100,  100,   11,
     .         0,    1,  100,    0,    0,    0,    1,    0,
     .         0,    1,    0,    0,    0,    0,    0,    0,
     .         0,    0/
      data tinit,tfina,tstep,hnatu,penal,sfnsc,sfnsp,sfnsr,
     .     sfnsd,sfdmo,thens,tosns,repns,tocns,toans,sfhec,
     .     thehe,toshe,toche,toahe,cripc,sfpcc,thepc,tospc,
     .     tocpc,arcpc,slopc,toapc,shcns,shche,sftuc,shctu,
     .     reptu,toctu,toatu,thcon,safns,densa,thrns,thrtu,
     .     thrhe,thrpc/
     .     0.0d0,0.9d0,1.0d0,2.0d0,0.0d0,0.0d0,0.0d0,0.0d0,
     .     0.0d0,0.0d0,1.0d0,0.1d0,1.0d0,0.1d0,0.1d0,0.0d0,
     .     1.0d0,0.1d0,0.1d0,0.1d0,0.5d0,0.0d0,1.0d0,0.1d0,
     .     0.1d0,0.0d0,1.0d0,0.1d0,0.0d0,0.0d0,0.0d0,0.0d0,
     .     1.0d0,0.1d0,0.1d0,1.0d0,1.0d0,0.0d0,0.0d0,0.0d0,
     .     0.0d0,0.0d0/
      data iorde/1,2,3/
      data istag/0,0,0/
      data iomes,ioufi,noutp/
     .         0,  0,
     .         0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
     .         0,  0,  0,  0,  0,  0,  0,  0,  0,  0/
      data iepns,ietns,iecns,ievns,iefns,kdela,kvila,kpola,
     .     kturb,iephe,iethe,ieche,ieshe,iejhe,kcvla,kdila,
     .     iepfs,ietfs,iupns,iuphe,iupfs,icoaf,kreys/
     .         1,    0,    0,    1,    0,    0,    0,    0,
     .         0,    0,    0,    0,    0,    0,    0,    0,
     .         0,    0,    1,    0,    0,    0,    0/
      data fcons,fvins,omgno,bouex,bourt,bougr,ravol  ,rdono/
     .     0.0d0,0.0d0,0.0d0,0.0d0,0.0d0,0.0d0,101.0d0,0.0d0/
      data tlimt/1.0d10/
      data lrevp,lwrvp/0,0/
      data kambo/1,1,1/
      data xrefe,drefe/8*0.0d0/
      data inist,nscon/.false.,.false./
      data ofram,afram,rfram,vfram,frano/32*0.0d0/
c
c*** Variables belonging to COM_AUXI
c   
      data cpuin,cpust,cpurn,cpnse,cpnss,cpnsl,cphee,cphes,
     .     cphel,cpfse,cpfss,cpfsl,cpuou,cpuda,cpuns,cpuhe,
     .     cpufs,cputu,cpuki,cpkie,cpkis,cpkil/
     .     22*0.0d0/

      data lprin,lwor1,ldaba,mepoi/4*0/

      end
