      subroutine custom
c***********************************************************************
c
c**** This routine fixes data according to the customer
c
c***********************************************************************
      implicit none
      include 'com_prob.f'
      include 'com_inou.f'
c
c***  Soler & Palau block of data
c
      if(custo.eq.1) then
        lenpo = 4                                           ! Modificable
        tlimt = 1.0d30
        iepns = 1
        iecns = 1
        iefns = 1
        fvins = 1.0d0
        turbu(8) = turbu(2)
        turbu(2) = 0.0d0
        if(ndime.eq.2) then
          nnode = 3
          ngaus = 3
        else if(ndime.eq.3) then
          nnode = 4
          ngaus = 4
        end if
        nnods = nnode
        inpco = 1
        lsnsc = 1
        lsnsp = 1
        lsnsr = 1
        iasns = 38                                          ! GMRES
        imsns = 1
        itwns = 1
        ip1p1 = 0                                           ! Modificable
        hnatu = 1.0d0
        sfnsc = 1.0d0
        sfnsp = 1.0d0
        sfnsr = 1.0d0
        sfnss = 0.0d0
        sfnsd = 0.5d0                                       ! Modificable
        call listen('CUSTOM')
        if(words(1).ne.'NUMER')
     .    call runend('RNUTRE: WRONG NUMERICAL TREATMENT CARD')
        do while(words(1).ne.'ENDNU')
          call listen('CUSTOM')
          if(words(1).eq.'TIMED') then
            tinit=getrea('INITI',0.0d0,'#INITIAL TIME')
            tfina=getrea('FINAL',0.9d0,'#FINAL TIME')
            tstep=getrea('TIMES',1.0d0,'#TIME STEP SIZE')
          else if(words(1).eq.'CONVE') then
            micns=getint('MAXIT',1,'#MAXIMUM NUMBER OF ITERATIONS')
            tocns=getrea('TOLER',0.1d0,'#CONVERGENCE TOLERANCE')
          else if(words(1).eq.'ALGEB') then
            mians=getint('MAXIT',1,'#MAXIMUM NUMBER OF ITERATIONS')
            toans=getrea('TOLER',0.1d0,'#SOLVER TOLERANCE')
            kryns=getint('KRYLO',100,'#KRYLOV DIMENSION')
          else if(words(1).eq.'OTHER') then
            continue
          end if
        end do
      end if

      end
