      subroutine nusube
c***********************************************************************
c
c**** This routine computes the number of linear subelements 
c
c***********************************************************************
      implicit none
      include 'com_prob.f'
      include 'com_auxi.f'
      integer   istop
c
c*** Number of subelements and nodes of the subelements
c
      istop=0
      nsubn=ndime+1
      if(ndime.eq.2) then
        if(nelty.eq.1) then
          if(nnode.eq.4) then
            nsube=2
          else if(nnode.eq.5) then
            nsube=4
          else if(nnode.eq.8) then
            nsube=6
          else if(nnode.eq.9) then
            nsube=8
          else
            istop=1
          end if
        else if(nelty.eq.2) then
          if(nnode.eq.3) then
            nsube=1
          else if(nnode.eq.4) then
            nsube=3
          else if(nnode.eq.6) then
            nsube=4
          else if(nnode.eq.7) then
            nsube=6
          else
            istop=1
          end if
        end if
      else if(ndime.eq.3) then
        if(nelty.eq.1) then
          if(nnode.eq.8) then
            nsube=5
          else if(nnode.eq.27) then
            nsube=40
          else
            istop=1
          end if
        else if(nelty.eq.2) then
          if(nnode.eq.4) then
            nsube=1
          else if(nnode.eq.5) then
            nsube=4
          else if(nnode.eq.10) then
            nsube=8
          else if(nnode.eq.15) then
            nsube=20
          else
            istop=1
          end if
        end if
      end if
c
c*** Stops the program if the element to be used is not programmed
c
      if(istop.eq.1)
     .  call runend('NUSUBE: SMOOTHING NOT READY FOR THIS ELEMENT')
c
c*** Computes the pointer for the nodal connections of the subelements
c
      call admemo(0,lnodw_p,nsube*nsubn*lenpo)
      mepoi=mepoi+nsube*nsubn*lenpo

      end
