      subroutine rficon
c***********************************************************************
c       
c**** This routine reads functions that define the boundary conditons
c
c***********************************************************************
      implicit none
      include 'com_prob.f'
      include 'com_inou.f'
      integer  mcomm,icomm,ifpan,ifpad,i
      parameter (mcomm=3)
      character*5 commd(mcomm)
      data commd/'PRESC','FUNCT','ENDFI'/
c
c*** Begin
c
      call listen('RFICON') 
      if(words(1).ne.'FIXIT')
     .  call runend('RFICON: WRONG FIXITY CONDITIONS CARD')
c
c*** Read, identify & execute apropriate command
c
 1000 call listen('RFICON')
      do icomm=1,mcomm
       if(words(1).eq.commd(icomm))
     .   go to (1,2,3),icomm
      end do
      call runend('RFICON: ERROR IN FIXITY CONDITIONS BLOCK')
c
c*** Prescriptions are not read, yet
c
    1 do while(words(1).ne.'ENDPR')
        call listen('NOREAD')
      end do
      go to 1000
c
c*** Functions definition
c
    2 do while(words(1).ne.'ENDFU')
        call listen('RFICON')
        if(words(1).eq.'DIRIC') then
          ifpad=getint('DIRIC',0,'#FUNCTION NUMBER')
          if(words(2).eq.'PARAB') then
            lfutd(ifpad)=1
          else if(words(2).eq.'PERIO') then
            lfutd(ifpad)=2
          end if
          do i=1,nmpad
            pdiri(i,ifpad)=param(i+1)
          end do
        else if(words(1).eq.'NEUMA') then
          ifpan=getint('NEUMA',0,'#FUNCTION NUMBER')
          if(words(2).eq.'PARAB') then
            lfutn(ifpan)=1
          else if(words(2).eq.'PERIO') then
            lfutn(ifpan)=2
          else if(words(2).eq.'WALFR') then
            lfutn(ifpan)=3
          end if
          do i=1,nmpan
            pneum(i,ifpan)=param(i+1)
          end do
        end if
      end do
      go to 1000
c
c*** Reading is finished
c
    3 return

      end
