      subroutine rrudat
c***********************************************************************
c
c**** This routine reads the type of run and the CPU limit
c
c***********************************************************************
      implicit none
      include 'com_prob.f'
      include 'com_inou.f'
      integer mcomm,icomm
      parameter (mcomm=5)
      character*5 commd(mcomm)
      data commd/'RUNTY','CPULI','LENGT','CUSTO','ENDRU'/
c
c*** Begin
c
      lenpo=4                                               ! default
      call listen('RRUDAT')
      if(words(1).ne.'RUNDA')
     .  call runend('RRUDAT: WRONG RUN_DATA CARD')
c
c*** Read, identify & execute apropriate command
c
 1000 call listen('RRUDAT')
      do icomm=1,mcomm
        if(words(1).eq.commd(icomm)) go to (1,2,3,4,5),icomm
      end do
      call runend('RRUDAT: ERROR IN RUN DATA BLOCK')
c
c*** Reads the type of run 
c
    1 rstar=.false.
      preli=.false.
      if(exists('RESTA')) rstar=.true.                      ! re-start run
      if(exists('PRELI')) preli=.true.                      ! preliminary run
      go to 1000
c
c*** Reads the CPU limit
c
    2 if(param(1).ne.0.0) tlimt=param(1)
      go to 1000
c
c*** Read the length of pointers (Default equal 4)
c
    3 lenpo=int(param(1))
      if (lenpo.eq.0) lenpo=4
      go to 1000
c
c*** Read the customer
c
    4 custo=0                                               ! Universal
      if(exists('S&P  ')) custo = 1                         ! Soler & Palau
      go to 1000
c
c*** Reading is finished
c
    5 return  

      end
