      subroutine runkey
c*********************************************************************
c
c**** This routine initializes signals & cputime, reads the problem 
c**** title and opens files
c
c*********************************************************************
      implicit none
      character*6 notes
      integer     filfl , i
      character*6 comst
      include 'com_auxi.f'
      include 'com_prob.f'
      include 'def_logi.f'
      data notes/' '/
      external silico

      machine='SILICON'            ! Machine type

      if (machine.eq.'SILICON') then
c       call signal(16,silico,-1)  ! interruption control >>> silicon only <<<
      else if (machine.eq.'CONVEX') then
c       call convex(32,0,0)        ! interruption control >>> convex only <<<
      else
        continue
      end if

      call blodat                  ! initialize some problem data (block data)

      call cputim(cpuin)           ! initialize cputime
      call opendk(0,ludat)         ! open data file
      
      do while((notes.ne.'FLOWAN') ! iterate until read heading card: "FANTOM"
     .  .and.(notes.ne.'FANTOM'))
        read(ludat,900) notes,title
      end do

      call rrudat                  ! reads the type of run and the cpu limit
      filfl=0
      if (rstar) filfl=1
      call opendk(filfl,lulog)     ! open log    file
      call opendk(filfl,lures)     ! open output file
      call opendk(    0,lusol)     ! open solver file

      write(lulog,905) notes,title
      write(lures,905) notes,title
      write(lusol,905) notes,title

  900 format(a6,a)
  905 format(///,5x,'******',/,
     .           5x,a6,' :',a66,/,
     .           5x,'******')

      end
