      subroutine shape2(    s,    t,nelty,nnode,nnodt,inint,
     .                  inpin,inpco,shape,deriv,heslo,neres,
     .                  nerep)
c*****************************************************************
c
c**** This routine calculates shape functions for 2D case
c
c*****************************************************************
      implicit real*8(a-h,o-z)
      real*8 deriv(2,nnodt), shape(nnodt), heslo(3,*)
c
c*** Calculate shape functions for main variables
c
      if (inint.eq.0) then
        call shcos2(    s,    t,nelty,nnode,
     .              shape,deriv,heslo,neres)
      else if (inint.eq.1) then
        call shcoh2(    s,    t,nelty,nnode,
     .              shape,deriv,heslo,neres)
      end if
c
c*** Calculate shape functions for pressure nodes
c
      nnods=nnodt-nnode
      if(nnods.eq.0) return
      if (inpin.eq.0 .and. inpco.eq.0) then
        call shdis2(    s,    t,nelty,nnods,
     .               shape(nnode+1),deriv(1,nnode+1))
      else if (inpin.eq.0 .and. inpco.eq.1) then
        call shcos2(    s,    t,nelty,nnods,
     .              shape(nnode+1),deriv(1,nnode+1),
     .              heslo(1,nnode+1),nerep)
      else if (inpin.eq.1 .and. inpco.eq.0) then
        call shdih2(    s,    t,nelty,nnods,
     .              shape(nnode+1),deriv(1,nnode+1))
      else if (inpin.eq.1 .and. inpco.eq.1) then
        call shcoh2(    s,    t,nelty,nnods,
     .              shape(nnode+1),deriv(1,nnode+1),
     .              heslo(1,nnode+1),nerep)
      end if
      
      end
