      subroutine recohe(shape,cartd,rtemp,btemp,elvel,eltem,
     .                  velas,veold,grate,ndime,nnode,iethe,
     .                  nelve,thhe1,denac,kfahe)
c***********************************************************************
c
c**** This routine computes the residual of the temperature equation
c**** due to the convective term 
c
c***********************************************************************
      implicit none
      integer    ndime,nnode,iethe,nelve,idime,inode,jnode,
     .           ievab,kfahe
      real*8     thhe1,denac,xmuit,btemp,vecdot
      real*8     shape(nnode),             cartd(ndime,nnode),
     .           rtemp(nnode),             elvel(ndime*nnode,nelve),
     .           eltem(nnode,iethe+1),     velas(ndime),
     .           veold(ndime),             grate(ndime)
c
c*** Velocity 
c
      if(kfahe.eq.1) then
        do idime=1,ndime
          ievab=idime-ndime
          velas(idime)=0.0d0
          do inode=1,nnode
            ievab=ievab+ndime
            velas(idime)=velas(idime)+shape(inode)*elvel(ievab,1)
          end do
        end do
c
c*** Contribution to the LHS
c
        xmuit=denac*thhe1
        do jnode=1,nnode
          rtemp(jnode)=rtemp(jnode)+
     .      xmuit*vecdot(velas,cartd(1,jnode),ndime)
        end do
      end if
c
c*** Contribution to the RHS
c
      if(thhe1.lt.0.99) then
        do idime=1,ndime
          ievab=idime-ndime
          veold(idime)=0.0
          do inode=1,nnode
            ievab=ievab+1
            veold(idime)=veold(idime)+shape(inode)*
     .        elvel(ievab,nelve)
          end do
        end do
        btemp=btemp-(1.0-thhe1)*denac*vecdot(veold,grate,ndime) 
      end if
      
      end
