      subroutine redins(cartd,rmom3,ndime,nnode,nevab,naxis,waxis,
     .                  gpcod,kfans)
c***********************************************************************
c
c**** This routine computes the residual of the Navier-Stokes equations
c**** due to the divergence of the velocity field
c
c***********************************************************************
      implicit none
      integer  kfans,ndime,nnode,nevab,naxis,idime,
     .         ievab,inode
      real*8   gpcod
      real*8   cartd(ndime,nnode),    rmom3(nevab),
     .         waxis(nnode*naxis)

      do idime=1,ndime
        if(kfans.eq.1) then
          ievab=idime-ndime
          do inode=1,nnode
            ievab=ievab+ndime
            rmom3(ievab)=cartd(idime,inode)
          end do
        end if
      end do
      
      if(naxis.eq.1) then              ! Axisymmetric contribution to div(u)
        if(kfans.eq.1) then
          ievab=-1
          do inode=1,nnode
            ievab=ievab+1
            rmom3(ievab)=rmom3(ievab)+waxis(inode)
          end do
        end if
      end if
      
      end
