      subroutine retehe(shape,rtemp,btemp,eltem,nnode,denac,
     .                  tstep,kfahe)
c***********************************************************************
c
c**** This routine computes the residual of the temperature equation
c**** due to the evolution in time
c
c***********************************************************************
      implicit none
      integer   nnode,jnode,kfahe
      real*8    btemp,denac,tstep,oltem,xmuit,vecdot
      real*8    shape(nnode), rtemp(nnode), eltem(nnode,2)

      xmuit=denac/tstep
      if(kfahe.eq.1) then
        do jnode=1,nnode
          rtemp(jnode)=rtemp(jnode)+xmuit*shape(jnode)
        end do
      end if
      oltem=vecdot(eltem(1,2),shape,nnode)
      btemp=btemp+denac*oltem/tstep

      end
