      subroutine temres(shape,cartd,hessi,rtem1,rtem2,btem1,
     .                  btem2,elvel,eltem,denac,denol,souac,
     .                  souol,difac,difol,velas,veold,grate,
     .                  alapl,ndime,nnode,ntens,nelve,iethe,
     .                  itwhe,ieche,ieshe,timhe,thhe1,tstep,
     .                  gpcod,naxis,nhess,kfahe)
c***********************************************************************
c
c**** This routine computes the residuals of the temperature equation
c**** within each element
c
c***********************************************************************
      implicit none
      integer   ndime,nnode,ntens,nelve,iethe,ieche,ieshe,itwhe,
     .          naxis,nhess,kfahe
      real*8    btem1,btem2,denac,denol,souac,souol,difac,
     .          difol,timhe,thhe1,tstep,gpcod
      real*8    shape(nnode),             cartd(ndime,nnode),
     .          hessi(ntens,nnode),       rtem1(nnode),
     .          rtem2(nnode),             elvel(ndime*nnode,nelve),
     .          eltem(nnode,1+iethe)
      real*8    velas(ndime),             veold(ndime),
     .          grate(ndime),             alapl(nnode)
      
      if(iethe+ieche+ieshe.eq.0) return
      
      if((iethe.eq.1).and.(itwhe.eq.1))
     .  call retehe(shape,rtem1,btem1,eltem,nnode,denac, ! Residual due to the
     .              tstep,kfahe)                         ! transient evolut.  

      if(ieche.eq.1)
     .  call recohe(shape,cartd,rtem1,btem1,elvel,eltem, ! Residual due to the
     .              velas,veold,grate,ndime,nnode,iethe, ! convective term
     .              nelve,thhe1,denac,kfahe)
      
      if(ieshe.eq.1)
     .  call resohe(btem1,thhe1,souac,souol,denol,denac) ! Residual due to 
                                                         ! source term
      if(timhe.gt.1.0e-4)
     .  call redihe(cartd,hessi,rtem2,btem2,eltem,alapl, ! Residual due to the
     .              ndime,ntens,nnode,naxis,gpcod,difac, ! diffusive term
     .              difol,iethe,thhe1,nhess,kfahe)

      end
