      subroutine temvsg(elpro,shape,hleng,elvel,chave,chade,
     .                  chadi,chale,ndime,nnode,nprod,lshec,
     .                  lshed,isubs,sfhec,timhe)
c**************************************************************************
c
c**** This routine computes the characteristic element velocity, density,
c**** diffusion and the stability times for the temperature equation
c
c**************************************************************************
      implicit none
      integer   idime,ndime,inode,nnode,ievab,nprod,
     .          lshec,lshed,isubs,igaus
      real*8    chade,chadi,elno1,sfhec,timhe,chale,
     .          diffu
      real*8    elpro(nprod),        shape(nnode),
     .          hleng(ndime),        elvel(ndime*nnode)
      real*8    chave(ndime,2)
c
c*** Characteristic density, specific heat and difussion
c
      chade=elpro(1      )*elpro(4-isubs)
      chadi=elpro(5-isubs)
      diffu=chadi/chade
c
c*** Characteristic element velocity
c
      call veczer(ndime*2,chave)
      do idime=1,ndime
        ievab=idime-ndime
        do inode=1,nnode
          ievab=ievab+ndime
          chave(idime,1)=chave(idime,1)+shape(inode)*
     .                                  elvel(ievab)
        end do
      end do
      call vecnor(chave(1,1),ndime,elno1,2)      
c
c*** Computes the stability time for the convective term
c
      timhe=0.0
      if(lshec.eq.1) then
        timhe = sfhec/(4.0*diffu/chale/chale + 2.0*elno1/chale)
      end if

      end
