      subroutine cvlaws(sphee,kcvla,spehe,speha,tvelo,grave,
     .                  vpres,vtemp,vfree,ndime)
c***********************************************************************
c
c**** This routine computes the specific heat as a dependent variable
c
c***********************************************************************
      implicit real*8(a-h,o-z)
      real*8  spehe(1)
      real*8  tvelo(ndime),  grave(ndime,ndime)
c
c*** Air region
c
      if(vfree.lt.1.0e-2) then
        sphee=speha
        return
      end if
c
c*** Constant specific heat
c
      if(kcvla.eq.0) then                          
        sphee=spehe(1)
      end if

      sphee=vfree*sphee+(1.0-vfree)*speha

      end
