      subroutine denlaw(dense,kdela,densi,densa,tvelo,grave,
     .                  vpres,vtemp,vfree,ndime)
C***********************************************************************
c
c**** This routine computes the density as a dependent variable
c
c***********************************************************************
      implicit none
      integer kdela,ndime
      real*8  densi(1),dense,densa,vpres,vtemp,vfree
      real*8  tvelo(ndime),  grave(ndime,ndime)

      if(vfree.lt.1.0e-2) then
        dense=densa
        return
      end if
      
      if(kdela.eq.0) then                             ! constant density
        dense=densi(1)
      end if

      dense=vfree*dense+(1.0-vfree)*densa

      end
