      subroutine diflaw(diffe,kdila,diffu,diffa,tvelo,grave,
     .                  vpres,vtemp,vfree,ndime)
c***********************************************************************
c
c**** This routine computes the conduction coefficient as a dependent
c**** variable
c
c***********************************************************************
      implicit real*8(a-h,o-z)
      real*8  diffu(1)
      real*8  tvelo(ndime),  grave(ndime,ndime)
c
c*** Air region
c
      if(vfree.lt.1.0e-2) then
        diffe=diffa
        return
      end if
c
c*** Constant conduction coefficient
c
      if(kdila.eq.0) then                          
        diffe=diffu(1)
      end if

      diffe=vfree*diffe+(1.0-vfree)*diffa

      end
