      subroutine turvst(tragl,hleng,elvel,chave,chale,ndime,
     .                  nnode,hnatu)
c***********************************************************************
c
c**** This routine computes the characteristic element length for
c**** the equations for the turbulence parameters 
c
c***********************************************************************
      implicit none
      integer   idime,ndime,inode,nnode,ievab
      real*8    elno1,elno2,hnatu,chale,pecl3
      real*8    tragl(ndime,ndime),hleng(ndime),elvel(ndime*nnode),
     .          chave(ndime,2)
c
c*** Characteristic element velocity
c
      call veczer(ndime*2,chave)
      do idime=1,ndime
        ievab=idime-ndime
        do inode=1,nnode
          ievab=ievab+ndime
          chave(idime,1)=chave(idime,1)+elvel(ievab)
        end do
        chave(idime,1)=chave(idime,1)/float(nnode)
      end do
c
c*** Characteristic element length
c
      call mbvab2(chave(1,2),tragl,chave(1,1),ndime,ndime)
      call vecnor(chave(1,1),ndime,elno1,2)      
      call vecnor(chave(1,2),ndime,elno2,2)
      if(elno2.gt.1.0e-8) then
        chale=hnatu*elno1/elno2
      else
        chale=hleng(1)
      end if

      end
