      subroutine outrst(veloc,presu,tempe,fresu,tkine,tener,cletu,
     .                  visct,elpro,wellf)
c***********************************************************************
c
c*** This routine writes variables in a re-start file
c
c***********************************************************************
      implicit none
      include 'com_prob.f'
      include 'com_auxi.f'
      include 'def_logi.f'
      logical*1 wellf
      integer   i,j
      real*8    veloc(ntotv,ncove),    presu(ntotp,ncopr),
     .          tempe(npoin,ncote),    fresu(npoin,ncofs),
     .          tkine(npoin,ncove),    tener(npoin,ncove),
     .          cletu(npoin,    2),    visct(npoin),
     .          elpro(nprod*ngaus*nelem)

      call opendk(0,lurst)
      write(lurst) iiter,istep,tstep,tactu,tkcom,tecom,dicom,
     .  kturb,ntotp,inpco

      if (iupns.eq.1.or.iepns.eq.1)
     .  write(lurst) ((veloc(i,j),i=1,ntotv),j=1,ncove)

      if (iepns.eq.1) then
        write(lurst) ((presu(i,j),i=1,ntotp),j=1,ncopr)
        if (kturb.eq.1) then
          write(lurst) (cletu(i,1),i=1,npoin)
        else if (kturb.ge.2) then
          write(lurst) ((cletu(i,j),i=1,npoin),j=1,2)
          write(lurst) (visct(i),i=1,npoin)
          write(lurst) ((tkine(i,j),i=1,npoin),j=1,ncove)
          if(kturb.eq.3.or.kturb.eq.4.or.kturb.eq.5) then
            write(lurst) ((tener(i,j),i=1,npoin),j=1,ncove)
          else if(kturb.ge.6) then
            call runend('OUTRST: WRITE TURBULENCE PARAMETER')
          end if
        end if
      end if
      
      if (iephe.eq.1.or.iuphe.eq.1)
     .  write(lurst) ((tempe(i,j),i=1,npoin),j=1,ncote)

      if (iepfs.eq.1.or.iupfs.eq.1)
     .  write(lurst) ((fresu(i,j),i=1,npoin),j=1,ncofs)

      write(lurst) (elpro(i),i=1,nprod*ngaus*nelem)

      close(lurst)
      if(.not.wellf) call runend('OUTRST: CPU TIME EXPIRED')

      end
