      subroutine recond(lnods,lpoty,lroty,veloc,presu,worve,elvec)
c***********************************************************************
c
c**** This routine recovers the bubble d.o.f. that have been eliminated
c
c***********************************************************************
      implicit none
      include 'com_prob.f'
      include 'com_auxi.f'
      integer   ipoi0                                       ! pointer
      integer   ipoi1,ipoi2,ievat,inode,ipoin,itotv,
     .          idime,itot0,itot1,ibopo,iroty
      integer   lnods(nnodt,nelem),    lpoty(npoin),
     .          lroty(nbopo)
      real*8    veloc(ntotv),          presu(ntotp),
     .          elvec(nevat),          worve(ndime)
c
c*** Deal with the slave nodes. VEL_slave=VEL_master (In local system)
c
      itot0=1
      do ipoin=1,npoin
        ibopo=lpoty(ipoin)
        if (ibopo.gt.0) then
          iroty=-lroty(ibopo)
          if (iroty.gt.0) then
            itot1=(iroty-1)*ndime+1
            call vecasi(ndime,veloc(itot1),veloc(itot0))
          end if
        end if
        itot0=itot0+ndime
      end do

      ipoi1=ndime*8                                         ! Pointers to ele-
      ipoi2=ipoi1+ndime*(nnode-1)*ndime*8                   ! mental matrices
c
c*** Scater of elemental velocities and pressures
c
      do ielem=1,nelem
        ievat=0
        do inode=1,nnode
          ipoin=lnods(inode,ielem)
          itotv=(ipoin-1)*ndime
          do idime=1,ndime
            itotv=itotv+1
            ievat=ievat+1
            elvec(ievat)=veloc(itotv)
          end do
        end do
        do inode=nnode+1,nnodt
          ievat=ievat+1
          ipoin=lnods(inode,ielem)-npoin
          elvec(ievat)=presu(ipoin)
        end do
c
c*** Recover eliminated velocities
c
        call poiass(%val(lmatb_p+(ielem-1)*lenpo),ipoi0)
        itotv=(lnods(nnode,ielem)-1)*ndime+1
        call mbvab0(veloc(itotv),%val(ipoi0+ipoi1),
     .              elvec,ndime,(nnode-1)*ndime)
        call vecadm(ndime,veloc(itotv),%val(ipoi0),
     .              veloc(itotv),-1.0)
        if (kpeel.eq.0) then
          call mbvab0(worve,%val(ipoi0+ipoi2),
     .                elvec(nnode*ndime+1),ndime,nnods)
          call vecadm(ndime,worve,veloc(itotv),veloc(itotv),
     .                -1.0)
        end if
      end do

      end
