      subroutine tuconv(tupar,tudif,reler,npoin,inons)
c***********************************************************************
c        
c**** This routine computes the relative error RELER norm for the 
c**** turbulence parameter TUPAR
c
c***********************************************************************
      implicit none
      include 'com_auxi.f'
      integer npoin,inons
      real*8  tupar(npoin,2), tudif(npoin), reler, rele1

      call veccom(one00,tupar(1,1),mone0,tupar(1,2),tudif,  ! t^i - t^i-1
     .  npoin)
      call vecnor(tudif,npoin,reler,inons)                  ! |t^i-t^i-1|
      call vecnor(tupar,npoin,rele1,inons)                  ! |t^i|
      reler=100.0*reler/rele1                               ! Relative error
      call vecasi(npoin,tupar(1,1),tupar(1,2))              ! Save values

      end
