      subroutine turre0(
     .  lnods,shape,objec,ileob,veloc,tkine,
     .  cletu,visct,produ,work1)
c***********************************************************************
c        
c**** This routine splits the object to compute the Reynold stress
c**** tensor
c      
c***********************************************************************
      implicit none
      include 'com_prob.f'
      include 'com_auxi.f'
      integer
     .  lnods(*), ileob(*)
      real*8
     .  shape(*), objec(*), veloc(*), tkine(*),
     .  cletu(*), visct(*), produ(*), work1(*)
c
c*** Implicit algebraic model
c
      if (turbu(15).lt.zero3) then
        call turre1(
     .    lnods,shape,objec(ileob(fcart)),veloc,tkine,
     .    cletu,visct,produ,
     .    work1(iturr( 1)),work1(iturr( 2)),work1(iturr( 3)),
     .    work1(iturr( 4)),work1(iturr( 5)),work1(iturr( 6)),
     .    work1(iturr( 7)),work1(iturr( 8)),work1(iturr( 9)))
c
c*** Explicit algebraic model
c
      else
        iturr( 1)=1                                         ! elvel(ndime,nnode,2)
        iturr( 2)=iturr( 1)+ndime*nnode*2                   ! elkin(nnode)
        iturr( 3)=iturr( 2)+nnode                           ! elene(nnode)
        iturr( 4)=iturr( 3)+nnode                           ! ellon(nnode)
        iturr( 5)=iturr( 4)+nnode                           ! wvect(ndime,ndime)
        iturr( 6)=iturr( 5)+ndime*ndime                     ! grave(ndime,ndime,2)
        iturr( 7)=iturr( 6)+ndime*ndime*2                   ! sstar(ndime,ndime)
        iturr( 8)=iturr( 7)+ndime*ndime                     ! wstar(ndime,ndime)
        iturr( 9)=iturr( 8)+ndime*ndime                     ! t(ndime,ndime,9)
        iturr(10)=iturr( 9)+ndime*ndime*9                   ! etain(5)
        iturr(11)=iturr(10)+5                               ! gfunc(9)
        iturr(12)=iturr(11)+9                               ! ttem1(ndime,ndime)
        iturr(13)=iturr(12)+ndime*ndime                     ! ttem2(ndime,ndime)
        iturr(14)=iturr(13)+ndime*ndime                     ! reyst(ndime,ndime)
        iturr(15)=iturr(14)+ndime*ndime                     ! iwork(2*nnode)
        call turre2(
     .    lnods,shape,objec(ileob(fcart)),objec(ileob(fhess)),
     .    veloc,tkine,cletu,visct,produ,
     .    work1(iturr( 1)),work1(iturr( 2)),work1(iturr( 3)),
     .    work1(iturr( 4)),work1(iturr( 5)),work1(iturr( 6)),
     .    work1(iturr( 7)),work1(iturr( 8)),work1(iturr( 9)),
     .    work1(iturr(10)),work1(iturr(11)),work1(iturr(12)),
     .    work1(iturr(13)),work1(iturr(14)),work1(iturr(15)))
      end if
        
      end
