      subroutine modul1(lnods,lnodb,lboel,coord,iffix,presc,ivapo,
     .                  tload,ivabo,veloc,presu,tempe,fresu,shape,
     .                  shaga,shapb,elpro,rhsid,work1)
c***********************************************************************
c                                                                      *
c                              OOOOOO                                  *
c                            OO      OO                                *
c                           OO  O  O  OO                               *
c                           OO        OO                               *
c                            OO      OO                                *
c                            OO      OO                                *
c                            OO      OO                                *
c                                                                      *
c***********************************************************************
      implicit real*8(a-h,o-z)
      include 'com_prob.f'
      include 'com_auxi.f'
      integer   lnods(*),lnodb(*),lboel(*),iffix(*),
     .          ivapo(*),ivabo(*)
      real*8    coord(*),presc(*),tload(*),veloc(*),
     .          presu(*),tempe(*),fresu(*),shape(*),
     .          shaga(*),shapb(*),elpro(*),rhsid(*),
     .          work1(*)

      call starts(lnods,lnodb,lboel,iffix,ivapo,     ! Start the computations 
     .            ivabo,coord,presc,tload,veloc,
     .            presu,tempe,fresu,shape,shaga,
     .            shapb,elpro,rhsid,work1)

      do while (tactu.lt.tfina)                      ! Loop over time steps
        call tmstep(ivapo,presc,elpro,veloc,presu,
     .              tempe,fresu,lnods,coord)         ! Step on time
        do while (nchek.ne.0.and.iiter.lt.miter)     ! Loop on iterations
          call iterat(lnods,lnodb,lboel,iffix,ivabo, ! Iterative scheme
     .                coord,presc,tload,veloc,presu,
     .                tempe,fresu,shape,shaga,shapb,
     .                elpro,rhsid,work1)
        end do                                       ! End of iterations loop
        call finish(iffix,lnods,coord,veloc,presu,   ! End of time step
     .              tempe,fresu,shape,elpro,work1)
        if(nchek.ne.0)                               ! Not  converged
     .    call runend('**** NOT CONVERGED **** ')
      end do                                         ! End of time steps loop
      call runend('**** END OF RUN **** ') 
      
      end
