      subroutine locbas(                                    ! Thinflow
     .  deriv,elcod,tanve,ndime,nnode,nelem,ielem,inode)
c
c*** Compute the tangential basis in each gauss point
c
      implicit none
      integer ndime,nnode,nelem,ielem,inode
      real*8  deriv(ndime,nnode),elcod(ndime,nnode),
     .        tanve(ndime,ndime-1,nnode,nelem)

      integer kdime,ldime,jnode
      real*8  dummy

      do kdime=1,ndime-1
        do ldime=1,ndime
          tanve(ldime,kdime,inode,ielem)=0.0d0
          do jnode=1,nnode
            tanve(ldime,kdime,inode,ielem)=
     .        tanve(ldime,kdime,inode,ielem)
     .        +deriv(kdime,jnode)*elcod(ldime,jnode)
          end do
        end do
        call vecuni(ndime,tanve(1,kdime,inode,ielem),dummy)
      end do

      end
