      subroutine neglno(lnods)
c*****************************************************************************
c      
c**** This routine modifies LNODS to account for the condensated degrees
c**** of freedom      
c
c*****************************************************************************
      implicit none
      include 'com_prob.f'
      integer  ielem
      integer  lnods(nnodt,nelem)

      if(ndime.eq.2) then
        if(nelty.eq.1) then                                 ! 2D quads
          if((nnode.eq.5).or.
     .       (nnode.eq.9)    ) then
            do ielem=1,nelem
              lnods(nnode,ielem)=-lnods(nnode,ielem)
            end do
          else
            nscon=.false.
          end if
        else if(nelty.eq.2) then                            ! 2D triangles
          if((nnode.eq.4).or.
     .       (nnode.eq.7)    ) then
            do ielem=1,nelem
              lnods(nnode,ielem)=-lnods(nnode,ielem)
            end do
          else
            nscon=.false.
          end if
        end if
      else if(ndime.eq.3) then
        if(nelty.eq.1) then                                 ! 3D bricks
          if((nnode.eq.9).or.
     .       (nnode.eq.27)   ) then
            do ielem=1,nelem
              lnods(nnode,ielem)=-lnods(nnode,ielem)
            end do
          else
            nscon=.false.
          end if
        else if(nelty.eq.2) then                            ! 3D tetrahedra
          if((nnode.eq.5 ).or.
     .       (nnode.eq.11).or.
     .       (nnode.eq.15)    ) then
            do ielem=1,nelem
              lnods(nnode,ielem)=-lnods(nnode,ielem)
            end do
          else
            nscon=.false.
          end if
        end if
      end if

      end
