      subroutine setbou
c*************************************************************************
c
c**** This routine allocates memory for the vector LBOTY(MBOUN), where
c
c           LBOTY(IBOUN) =  0  : Natural boundary condition
c                        = -1  : Open boundary for momentum equation
c                        = -2  : Open boundary for energy equation
c                        = -3  : Open boundary for both equations
c 
c*************************************************************************
      implicit none
      include 'com_prob.f'
      include 'com_auxi.f'
      integer   lbyts

      mboun=max(nboun,1)
      latmo=0                                               ! Flag of atmosfer.Str.
      nclbo=3
      lbyts=(mboun*nclbo)*lenpo
      call admemo(0,lboty_p,lbyts)
      call lvecze(mboun*nclbo,%val(lboty_p))
      mepoi=mepoi+lbyts
      
      end

