      subroutine vernor(lnodb,lpoty,shapb,exnor,baloc,balow)
c***********************************************************************
c
c**** This routine verifies that the normal at boundary integration
c**** points is external
c
c***********************************************************************
      implicit real*8(a-h,o-z)
      include 'com_prob.f'
      include 'com_auxi.f'
      integer  lnodb(nnodb,nboun), lpoty(npoin)
      real*8   shapb(nnodb,ngaub), exnor(ndime,ndime,nbopo),
     .         balow(ndime),       baloc(ndime,ndime,ngaub)

      do igaub=1,ngaub
        call veczer(ndime,balow)
        do inodb=1,nnodb                                    ! Interpolate the
          ipoin=lnodb(inodb,iobje)                          ! normals from
          ibopo=lpoty(ipoin)                                ! nodes to bounda-
          do idime=1,ndime                                  ! ry gauss points
            balow(idime)=balow(idime)+
     .        shapb(inodb,igaub)*exnor(idime,1,ibopo)
          end do
        end do
        do idime=1,ndime
          call vecuni(ndime,baloc(1,idime,igaub),dummy)     ! Normalize  BALOC
        end do
        produ=vecdot(baloc(1,ndime,igaub),balow,ndime)
        if (produ.lt.0.0d0) then                            ! If n1.n2 < 0
          do idime=1,ndime                                  ! the normal is not
            baloc(idime,    1,igaub)=                       ! the external one
     .        -baloc(idime,    1,igaub)                     ! t1=-t1
            baloc(idime,ndime,igaub)=
     .        -baloc(idime,ndime,igaub)                     ! n =-n
          end do
        end if
      end do
      
      end
