      subroutine upddir(ivapo,presc,presv,veloc,tempe,fresu)
c***********************************************************************
c
c**** This routine updates the Dirichlet type prescriptions
c
c***********************************************************************
      implicit real*8(a-h,o-z)
      include 'com_prob.f'
      include 'com_auxi.f'
      integer  ivapo(nltot)
      real*8   presc(nltot), veloc(ntotv,ncove),
     .  presv(ntotv),        tempe(npoin,ncote),
     .  fresu(npoin,ncofs)
c
c*** Update prescribed velocities
c
      if(iupns.eq.1) then
        do idime=1,ndime
          do ipoin=1,npoin
            itotv=(ipoin-1)*ndime+idime
            ifpad=ivapo(itotv)
            if(ifpad.ne.0) then
              ifuge=lfutd(ifpad)
              veloc(itotv,1)=presc(itotv)
     .          *funcdi(pdiri(1,ifpad),nmpad,ifuge,tactu)
              presv(itotv)=veloc(itotv,1)
              if((kfans.eq.2).and.(imsns.gt.0)) kfans=0
            end if
          end do
        end do
      end if
c
c*** Update prescribed temperatures
c
      if(iuphe.eq.1) then
        do ipoin=1,npoin
          itotv=ntotv+ipoin
          ifpad=ivapo(itotv)
          if(ifpad.ne.0) then
            ifuge=lfutd(ifpad)
            tempe(itotv,1)=presc(itotv)
     .        *funcdi(pdiri(1,ifpad),nmpad,ifuge,tactu)
            if((kfahe.eq.2).and.(imshe.gt.0)) kfahe=0
          end if
        end do
      end if
c
c*** Update the prescribed free surface
c
      if(iupfs.eq.1) then
        do ipoin=1,npoin
          itotv=ntotv+iephe*npoin+ipoin
          ifpad=ivapo(itotv)
          if(ifpad.ne.0) then
            ifuge=lfutd(ifpad)
            fresu(itotv,1)=presc(itotv)
     .        *funcdi(pdiri(1,ifpad),nmpad,ifuge,tactu)
            if((kfapc.eq.2).and.(imshe.gt.0)) kfapc=0
          end if
        end do
      end if

      end 
