      subroutine updrem
c***********************************************************************
c
c**** This routine updates the angular velocity and acceleration of the
c**** frame of reference
c
c***********************************************************************
      implicit none
      include 'com_prob.f'
      include 'com_auxi.f'
      integer  idime
      real*8   funcre , funcrd
c
c*** Initialization
c
      frano(1,2)=frano(1,1) ! norm of angular velocity
      frano(2,2)=0.0        ! norm of angular acceleration
      frano(3,2)=frano(3,1) ! norm of linear velocity
      frano(4,2)=0.0        ! norm of linear acceleration
      do idime=1,3
        ofram(idime,2)=ofram(idime,1)
        afram(idime,2)=afram(idime,1)
        vfram(idime,2)=vfram(idime,1)        
        rfram(idime,2)=rfram(idime,1)
      end do
c
c*** Update the norm of the angular velocity w, its derivative and the
c*** acceleration of the frame of reference when a periodic or parabolic
c*** evolution is prescribed
c
      if(lfuto.gt.0) then
        frano(1,2)=frano(1,1)*funcre(pomeg,nmpao,lfuto,tactu)
        frano(2,2)=frano(1,1)*funcrd(pomeg,nmpao,lfuto,tactu)
      end if
      if(lfuta.gt.0) then
        frano(3,2)=frano(3,1)*funcre(pacce,nmpaa,lfuta,tactu)
        frano(4,2)=frano(3,1)*funcrd(pacce,nmpaa,lfuta,tactu)
      end if

      end 
