      subroutine geofem(lnods,lnodw,coord,s_tit)
      implicit      real*8 (a-h,o-z)
      include      'Contro.h'
      character*6   s_tit
      dimension     lnods(nnode,nelem), lnodw(12,*), coord(ndime,npoin)

      write(nog,10) 1,'C',s_tit
      write(nog,10) 2,'C','Coord.'
      do ipoin  = 1,npoin
        write(nog,20) -1,ipoin,(coord(i,ipoin),i=1,ndime)
      enddo
      write(nog,30) -3
      write(nog,10) 3,'C','Conne.'

      nnodw = 0
      istop = 1
      if(ndime.eq.2) then
        if(nnode.eq.4.and.nelty.eq.2) then                  ! P1+bubble
          call top004(lnods,nelem,nnode,lnodw,melem,nnodw)
          iflag = 7
          istop = 0
        else if(nnode.eq.5) then                            ! Q1+bubble
          call top05a(lnods,nelem,nnode,lnodw,melem,nnodw)
          iflag = 7
          istop = 0
        else if(nnode.eq.7) then                            ! P2+bubble = P2^+
          call top007(lnods,nelem,nnode,lnodw,melem,nnodw)
          iflag = 9
          istop = 0
        else if(nnode.eq.10) then                           ! P3
          call top10a(lnods,nelem,nnode,lnodw,melem,nnodw)
          iflag = 7
          istop = 0 
        else if(nnode.eq.9) then                            ! Q2
          call top09a(lnods,nelem,nnode,lnodw,melem,nnodw)
          iflag = 9
          istop = 0
        else if(nnode.eq.16) then                           ! Q3
          call top016(lnods,nelem,nnode,lnodw,melem,nnodw)
          iflag = 9
          istop = 0
        endif
      else if(ndime.eq.3) then
        if(nnode.eq.5) then                                 ! P1+bubble
          call top05b(lnods,nelem,nnode,lnodw,melem,nnodw)
          iflag = 3
          istop = 0
        else if(nnode.eq.9) then                            ! Q1+bubble
          call top09b(lnods,nelem,nnode,lnodw,melem,nnodw)
          iflag = 3
          istop = 0
        else if(nnode.eq.11) then                           ! P2+bubble
          call top011(lnods,nelem,nnode,lnodw,melem,nnodw)
          iflag = 3
          istop = 0
        else if(nnode.eq.15) then                           ! P2+bubbles = P2^+
          call top015(lnods,nelem,nnode,lnodw,melem,nnodw)
          iflag = 1
          istop = 0
        else if(nnode.eq.27) then                           ! Q2
          call top027(lnods,nelem,nnode,lnodw,melem,nnodw)
          iflag = 1
          istop = 0
        endif
      endif

      if(nnodw.eq.0) then
        if(ndime.eq.2) then
          if(nnode.eq.3) then
            iflag = 7
            istop = 0
          else if(nnode.eq.4) then
            iflag = 9
            istop = 0
          else if(nnode.eq.6) then
            iflag = 8
            istop = 0 
          else if(nnode.eq.8) then
            iflag = 10
            istop = 0
          end if
        else if(ndime.eq.3) then
          if(nnode.eq.4) then
            iflag = 3
            istop = 0
          else if(nnode.eq.8) then
            iflag = 1
            istop = 0
          else if(nnode.eq.10) then
            iflag = 6           
            istop = 0
          else if(nnode.eq.20) then
            iflag = 17
            istop = 0
          end if
        end if
      end if

      if(istop.eq.1) call runend('GEOFEM: NOT AVAILABLE ELEMENT')
      
      if(nnodw.eq.0) then
        do ielem = 1,nelem
          write(nog,40) -1,ielem,iflag,1,1
          write(nog,40) -2,(lnods(inode,ielem),inode=1,nnode)
        end do
      else 
        do ielem = 1,melem
          write(nog,40) -1,ielem,iflag,1,1
          write(nog,40) -2,(lnodw(inode,ielem),inode=1,nnodw)
        end do
      end if
      write(nog,30) -3

   10 format(1x,i4,a1,a6)
   20 format(1x,i2,i5,3e12.5)
   30 format(1x,i2)
   40 format(1x,i2,20i5)
      end 
