      subroutine wrifor(istep,ttime,iiter,fflow,iste0,ttim0,fflo0)
      implicit      real*8 (a-h,o-z)
      include 'Contro.h'
      real fflow(3,4,ngrfo),fflo0(3,4,ngrfo)
      
      if (istep.ne.iste0) then
        write(nfo,*)
        write(nfo,'(" >>> CONVERGED FORCES: STEP=",i5," TIME=",e14.7)')
     .    iste0,ttim0
        do j=1,ngrfo
          k=2
          fnorm=sqrt(fflo0(1,k,j)*fflo0(1,k,j)
     .      +fflo0(2,k,j)*fflo0(2,k,j)
     .      +fflo0(3,k,j)*fflo0(3,k,j))
          write(nfo,'(" P_FIN ",i3,1x,i5,4(1x,e14.7))')
     .      j,iste0,(fflo0(i,k,j),i=1,3),fnorm

          k=1
          fnorm=sqrt(fflo0(1,k,j)*fflo0(1,k,j)
     .      +fflo0(2,k,j)*fflo0(2,k,j)
     .      +fflo0(3,k,j)*fflo0(3,k,j))
          write(nfo,'(" V_FIN ",i3,1x,i5,4(1x,e14.7))')
     .      j,iste0,(fflo0(i,k,j),i=1,3),fnorm

          k=4
          fnorm=sqrt(fflo0(1,k,j)*fflo0(1,k,j)
     .      +fflo0(2,k,j)*fflo0(2,k,j)
     .      +fflo0(3,k,j)*fflo0(3,k,j))
          write(nfo,'(" P_TFI ",i3,1x,i5,4(1x,e14.7))')
     .      j,iste0,(fflo0(i,k,j),i=1,3),fnorm

          k=3
          fnorm=sqrt(fflo0(1,k,j)*fflo0(1,k,j)
     .      +fflo0(2,k,j)*fflo0(2,k,j)
     .      +fflo0(3,k,j)*fflo0(3,k,j))
          write(nfo,'(" V_TFI ",i3,1x,i5,4(1x,e14.7))')
     .      j,iste0,(fflo0(i,k,j),i=1,3),fnorm

          if (j.ne.ngrfo) write(nfo,'(78("-"))')
        end do
        write(nfo,'(78("*"))')
        write(nfo,*)
      end if

      if (istep.ne.-1) then
        write(nfo,*)
        write(nfo,'(" STEP=",i5," TIME=",e14.7," ITER=",i5)')
     .    istep,ttime,iiter
        do j=1,ngrfo
          k=2
          fnorm=sqrt(fflow(1,k,j)*fflow(1,k,j)
     .      +fflow(2,k,j)*fflow(2,k,j)
     .      +fflow(3,k,j)*fflow(3,k,j))
          write(nfo,'(" P_FOR ",i3,1x,i5,4(1x,e14.7))')
     .      j,istep,(fflow(i,k,j),i=1,3),fnorm

          k=1
          fnorm=sqrt(fflow(1,k,j)*fflow(1,k,j)
     .      +fflow(2,k,j)*fflow(2,k,j)
     .      +fflow(3,k,j)*fflow(3,k,j))
          write(nfo,'(" V_FOR ",i3,1x,i5,4(1x,e14.7))')
     .      j,istep,(fflow(i,k,j),i=1,3),fnorm

          k=4
          fnorm=sqrt(fflow(1,k,j)*fflow(1,k,j)
     .      +fflow(2,k,j)*fflow(2,k,j)
     .      +fflow(3,k,j)*fflow(3,k,j))
          write(nfo,'(" P_TOR ",i3,1x,i5,4(1x,e14.7))')
     .      j,istep,(fflow(i,k,j),i=1,3),fnorm

          k=3
          fnorm=sqrt(fflow(1,k,j)*fflow(1,k,j)
     .      +fflow(2,k,j)*fflow(2,k,j)
     .      +fflow(3,k,j)*fflow(3,k,j))
          write(nfo,'(" V_TOR ",i3,1x,i5,4(1x,e14.7))')
     .      j,istep,(fflow(i,k,j),i=1,3),fnorm

          write(nfo,'(78("-"))')
        end do
      end if

      end
