      subroutine difsur(shapb,derib,baloc,gpcob,bocod,iboun,eucta,
     .                  ndime,ndimb,nnodb,ngpco,jeror)
c***********************************************************************
c
c**** This routine computes the norm of the local basis vectors for 1D
c**** and 2D manifolds 
c
c***********************************************************************
      implicit real*8(a-h,o-z)
      include 'def_logi.f'
      real*8  shapb(nnodb), derib(ndimb,nnodb), baloc(ndime,ndime), 
     .        gpcob(ndime), bocod(ndime,nnodb)
c
c*** Calculate the radial coordinate of the sampling points if necessary
c
      call mbvab0(gpcob,bocod,shapb,ndime,nnodb)
c
c*** Evaluates the tangent vectors
c
      call mbmabt(baloc,bocod,derib,ndime,ndimb,nnodb)
c
c*** Computes the normal vector 
c
      if(ndime.eq.2) then
        baloc(1,2)= baloc(2,1)
        baloc(2,2)=-baloc(1,1)
      end if
      if(ndime.eq.3) call vecpro(baloc(1,1),baloc(1,2),baloc(1,3))
c
c*** Computes the Euclidian norm of the normal vector
c
      call vecnor(baloc(1,ndime),ndime,eucta,    2)
c
c*** Checks if the measure is positive
c
      if(eucta.le.0.0) then
        jeror=jeror+1
        write(lures,600) iboun
        write(lulog,600) iboun
      end if
  600 format(/,5x,'>>> ZERO MEASURE IN BOUNDARY NUMBER ',i5)

      end
