      subroutine nvstra(lboel,shapb,tract,dsurf,dtins,elrhs,
     .                  nnodb,ndime,nevat)
c*********************************************************************
c
c**** This routine computes the RHS for the Navier-Stokes equations
c**** due to the contribution of the boundaries (surface traction)
c
c*********************************************************************
      implicit none
      integer   nnodb,ndime,nevat,ievab,inodb,idime
      real*8    dsurf,dtins
      integer   lboel(nnodb)
      real*8    shapb(nnodb),    tract(ndime),    elrhs(nevat)

      ievab=0
      do inodb=1,nnodb
        ievab=(lboel(inodb)-1)*ndime
        do idime=1,ndime
          ievab=ievab+1
          elrhs(ievab)=elrhs(ievab)
     .      +tract(idime)*shapb(inodb)
     .      *dtins*dsurf
        end do
      end do

      end
