      subroutine bougat(lnodb,lboel,coord,veloc,presu,tempe,fresu,
     .                  bocod,bovel,bopre,botem,bofrs,shape,shaga,
     .                  elpre,lnods,itask)
c***********************************************************************
c
c**** This routine performs the gather operations previous to call the
c**** boundary library
c
c***********************************************************************
      implicit real*8(a-h,o-z)
      include 'com_prob.f'
      include 'com_auxi.f'
      integer   lnodb(nnodb),       lboel(nnodb+1),
     .          lnods(nnodt)
      real*8    coord(ndime,npoin), veloc(ntotv,ncove),
     .          presu(ntotp,ncopr), tempe(npoin,ncote),
     .          fresu(npoin,ncofs)
      real*8    bocod(ndime,nnodb), bovel(ndime*nnodb,ncove-iepns),
     .          bopre(nnodb,ncopr-iepns), botem(nnode,ncote-iephe),
     .          bofrs(nnode,ncofs-iepfs), elpre(nnods,ncopr-iepns),
     .          shape(nnodt,ngaus),       shaga(ngaus,nnode)
c
c*** Gather of coordinates
c      
      call gatvec(lnodb,coord,bocod,ndime,nnodb,npoin)
c
c*** Gather of velocities 
c
      if(iepns.eq.1) then
        call gatvec(lnodb,veloc(1,2),bovel(1,1),ndime,nnodb,npoin)
        if(ietns.eq.1)
     .  call gatvec(lnodb,veloc(1,3),bovel(1,2),ndime,nnodb,npoin)
      else if(iupns.eq.1) then
        call gatvec(lnodb,veloc(1,1),bovel(1,1),ndime,nnodb,npoin)
      end if
c
c*** Gather of pressures
c
      if(iepns.eq.1) then
        call rlnods(lnods,nnodt,nnode, 1,-npoin)
        call gatvec(lnods(nnode+1),presu(1,2),elpre(1,1),1,nnods,
     .    ntotp)
        call disgat(lboel,elpre(1,1),bopre(1,1),shape,shaga,nnodb,
     .    nnods,nnode,nnodt,ngaus)
        if(ietns.eq.1) then
          call gatvec(lnods(nnode+1),presu(1,3),elpre(1,2),1,nnods,
     .      ntotp)
          call disgat(lboel,elpre(1,2),bopre(1,2),shape,shaga,nnodb,
     .      nnods,nnode,nnodt,ngaus)
        end if
        call rlnods(lnods,nnodt,nnode, 1, npoin)
      else if(iupns.eq.1) then
        call rlnods(lnods,nnodt,nnode, 1,-npoin)
        call gatvec(lnods(nnode+1),presu(1,1),elpre(1,1),1,nnods,
     .    ntotp)
        call disgat(lboel,elpre(1,1),bopre(1,1),shape,shaga,nnodb,
     .    nnods,nnode,nnodt,ngaus)
        call rlnods(lnods,nnodt,nnode, 1, npoin)
      end if
c
c*** Gather of temperatures
c      
      if(iephe.eq.1) then
        call gatvec(lnodb,tempe(1,2),botem(1,1),1,nnodb,npoin)
        if(iethe.eq.1)
     .  call gatvec(lnodb,tempe(1,3),botem(1,2),1,nnodb,npoin)
      else if(iuphe.eq.1) then
        call gatvec(lnodb,tempe(1,1),botem(1,1),1,nnodb,npoin)
      end if
c
c*** Gather of free-surface values
c      
      if(iepfs.eq.1) then
        call gatvec(lnodb,fresu(1,2),bofrs(1,1),1,nnodb,npoin)
        if(iethe.eq.1)
     .  call gatvec(lnodb,fresu(1,3),bofrs(1,2),1,nnodb,npoin)
      else if(iupfs.eq.1) then
        call gatvec(lnodb,fresu(1,1),bofrs(1,1),1,nnodb,npoin)
      end if
      
      end
