      subroutine disgat(lboel,elvec,bovec,shape,shaga,nnodb,nnods,
     .                  nnode,nnodt,ngaus)
c***********************************************************************
c
c**** This routine performs the extrapolation of a vector ELVEC(NNODS) 
c**** defined in some interior points of an element to a vector BOVEC
c**** defined in the nodes of a boundary of the element
c    
c***********************************************************************
      implicit real*8(a-h,o-z)
      integer   lboel(nnodb)
      real*8    elvec(nnods),        bovec(nnodb),
     .          shape(nnodt,ngaus),  shaga(ngaus,nnode)

      do inode=1,nnode
        inodb=0
        jnodb=0
        do while((inodb.eq.0).and.(jnodb.lt.nnodb))
          jnodb=jnodb+1
          jnode=lboel(jnodb)
          if(jnode.eq.inode) inodb=jnodb
        end do
        if(inodb.ne.0) then
          bovec(inodb)=0.0
          do igaus=1,ngaus
            vecga=0.0
            do inods=1,nnods
              vecga=vecga+shape(nnode+inods,igaus)*elvec(inods)
            end do
            bovec(inodb)=bovec(inodb)+shaga(inode,igaus)*vecga
          end do
        end if
      end do

      end
