      subroutine coinod(liste,norep,lnods,coord,nnode,node0,node1,
     .                  nelem,ndime,npoii,nlist,zeroc)
c***************************************************************************
c                 
c**** This routine computes the nodal point with lowest nodal number that
c**** coincides with a point belonging to the elements of the list being
c**** considered      
c                 
c***************************************************************************
      implicit none
      integer   nnode,node0,node1,nelem,ndime,npoii,nlist,ipoin,
     .          jpoin,ilist,jlist,ielem,jelem,inode,jnode
      integer   liste(nlist), lnods(nnode,nelem), norep(npoii)
      real*8    coord(ndime,npoii)
      real*8    dista,zeroc
      logical*1 gouon
c
c*** Take one element and loop over its nodes
c
      do ilist=1,nlist 
        ielem=liste(ilist)
        inode=node0-1
        do while(inode.lt.node1)
          inode=inode+1
          ipoin=lnods(inode,ielem)
c
c*** Loop over the other elements and their nodes
c          
          do jlist=ilist+1,nlist
            jelem=liste(jlist)
            jnode=node0-1
            gouon=.true.
            do while((jnode.lt.node1).and.(gouon))
              jnode=jnode+1
              jpoin=lnods(jnode,jelem)
c
c*** Check if IPOIN must be replaced by JPOIN
c              
              dista=0.0
              dista=(coord(1,ipoin)-coord(1,jpoin))**2
     .          +   (coord(2,ipoin)-coord(2,jpoin))**2
              if(ndime.eq.3) dista = dista 
     .          +   (coord(3,ipoin)-coord(3,jpoin))**2
              dista = sqrt(dista)
              if(dista.lt.zeroc) then
                if(jpoin.lt.ipoin) then
                  if((norep(ipoin).gt.jpoin).or.norep(ipoin).eq.0)
     .              norep(ipoin)=jpoin
                  gouon=.false.
                else if(jpoin.gt.ipoin) then
                  if((norep(jpoin).gt.ipoin).or.norep(jpoin).eq.0)
     .              norep(jpoin)=ipoin
                  gouon=.false.
                end if
              end if
            end do
          end do
        end do
      end do

      end
