      subroutine elreno(norep,lnods,coord,nnode,node0,node1,
     .                  nelem,ndime,npoii,imcoo,npoif)
c***************************************************************************
c                 
c**** This routine computes the number of non-repeated nodes and redefines
c**** the arrays LNODS and COORD      
c                 
c***************************************************************************
      implicit none
      integer   nnode,node0,node1,nelem,ndime,npoii,npoif,
     .          ipoin,jpoin,idime,ielem,inode,imcoo
      integer   norep(npoii), lnods(nnode,nelem)
      real*8    coord(ndime,npoii)
c
c*** Constructs the list of new node numbers accounting for repetitions
c
      npoif=0
      do ipoin=1,npoii
        jpoin=norep(ipoin)
        if(jpoin.eq.0) then
          npoif=npoif+1
          norep(ipoin)=npoif
        else if(jpoin.gt.0) then
          norep(ipoin)=norep(jpoin)
        end if
      end do
c
c*** Redefine COORD
c
      if(imcoo.eq.1) then
        do ipoin=1,npoii
          jpoin=norep(ipoin)
          do idime=1,ndime
            coord(idime,jpoin)=coord(idime,ipoin)
          end do
        end do
      end if
c
c*** Redefine LNODS
c
      do ielem=1,nelem
        do inode=node0,node1
          ipoin=lnods(inode,ielem)
          lnods(inode,ielem)=norep(ipoin)
        end do
      end do

      end
