      subroutine btdbar(aglob,aloca,bmatr,spaci,spaco,ndimb,ntens)
c**********************************************************************
c                                      
c**** This routine computes Ag = Bt Al B  when Ag and Al are stored 
c**** as arrays (Ag := aglob, Al := aloca, B := bmatr) of NTENS com-
c**** ponents.
c
c**********************************************************************
      implicit real*8(a-h,o-z)
      real*8  aloca(ntens),  aglob(ntens),  bmatr(ndimb,ndimb)
      real*8  spaco(ndimb,ndimb), spaci(ndimb,ndimb)
c
c*** Transforms the initial array into a symmetric matrix
c
      call vetoma(aloca,spaco,ndimb,ntens)
c
c*** Computes the matrix product
c
      call btdbma(spaci,spaco,bmatr,ndimb,ndimb)
c
c*** Transforms the symmetric matrix into an array
c
      call matove(spaci,aglob,ndimb,ntens)
      
      end
