      subroutine btdbma(aglob,aloca,bmatr,n1,n2)
c**********************************************************************
c                                      
c**** This routine computes Ag = Bt Al B  when Ag and Al are stored 
c**** as full matrices (Ag := aglob, Al := aloca, B := bmatr). The di-
c**** mensions are Al -> Mat(n1,n1), Ag -> Mat(n2,n2), B -> Mat(n2,n1) 
c
c**********************************************************************
      implicit real*8(a-h,o-z)
      real*8  aloca(n1,n1), aglob(n2,n2), bmatr(n1,n2)

      do i=1,n2
        do j=1,n2
          aglob(i,j)=0.0
          do k=1,n1
            do l=1,n1
              aglob(i,j)=aglob(i,j)+bmatr(k,i)*aloca(k,l)*bmatr(l,j)
            end do
          end do
        end do
      end do

      end
