      subroutine invert(a,nmax,ndm)
c***********************************************************************
c
c**** This routine performs the inversion of a ndm*ndm square matrix 
c**** or just part of it (nmax*nmax)
c
c***********************************************************************
      implicit real*8(a-h,o-z)
      real*8 a(ndm,ndm)

      do n = 1,nmax
        d = a(n,n)
        do j = 1,nmax
          a(n,j) = -a(n,j)/d
        end do
        do i = 1,nmax
          if(n.ne.i) then
            do j = 1,nmax
              if(n.ne.j) a(i,j) = a(i,j) +a(i,n)*a(n,j)
            end do
          end if
          a(i,n) = a(i,n)/d
        end do
        a(n,n) = 1.0/d
      end do

      end
