      subroutine mbmaa0(a,n)
c********************************************************************
c
c**** This routine evaluates the matrix product A^2 = A A , where
c**** A -> Mat(n,n). The result is stored in A. Only n=2 and 3 is
c**** allowed
c
c********************************************************************
      implicit none
      integer i,n
      real*8 a(n,n),a11,a12,a21,a22

      a11=0.0
      a12=0.0
      a21=0.0
      a22=0.0
      do i=1,n
        a11=a11+a(1,i)*a(i,1)
        a12=a12+a(1,i)*a(i,2)
        a21=a21+a(2,i)*a(i,1)
        a22=a21+a(2,i)*a(i,2)
      end do
      a(1,1) = a11
      a(1,2) = a12
      a(2,1) = a21
      a(2,2) = a22

      end
