      SUBROUTINE RESTDK(NUNIT,IFLAG,MATRI,LENGH,LENRC,NRCUR)
C***********************************************************************
C
C***THIS ROUTINE WRITES (IFLAG=1) OR READS (IFLAG=2)
C    ONE MATRIX ('MATRI' WHICH LENGTH IS 'LENGH') TO OR FROM
C    'NRCUR'   CURRENT RECORD POINTER OF 'NUNIT' FILE
C
C***********************************************************************
      INTEGER   MATRI(LENGH)
C
C     LENWD=LENRC                   !VAX/VMS     length of record in words
      LENWD=LENRC/4                 !CONVEX/UNIX length of record in words
C
      NREST=LENGH-(LENGH/LENWD)*LENWD       ! # of resting words
      NFULL=LENGH-NREST                     ! # of full records
C
      IF(IFLAG.EQ.2) THEN     ! READ FROM DISK
        DO ILENG=1,NFULL,LENWD
          CALL READDK(NUNIT,MATRI(ILENG),LENWD,NRCUR)    ! full records
          NRCUR=NRCUR+1
        ENDDO
        IF(NREST.GT.0) THEN
          CALL READDK(NUNIT,MATRI(NFULL+1),NREST,NRCUR)  ! resting words
          NRCUR=NRCUR+1
        ENDIF
      ELSE                    ! WRITE TO DISK
        DO ILENG=1,NFULL,LENWD
          CALL WRITDK(NUNIT,MATRI(ILENG),LENWD,NRCUR)    ! full records
          NRCUR=NRCUR+1
        ENDDO
        IF(NREST.GT.0) THEN
          CALL WRITDK(NUNIT,MATRI(NFULL+1),NREST,NRCUR)  ! resting words
          NRCUR=NRCUR+1
        ENDIF
      ENDIF
C
      END
