      subroutine shafun(exisp,etasp,ezeta,ndime,nelty,nnode,nnodt,
     .                  ntens,inint,inpin,inpco,shape,deriv,heslo,
     .                  nhess,nerep)
c***********************************************************************
c
c**** This routine evaluates shape functions and their derivatives
c**** for linear and quadratic isoparametric elements
c
c***********************************************************************
      implicit none
      integer  ndime,nelty,nnode,nnodt,ntens,inint,inpin,
     .         inpco,nhess,nerep,nnods,neres
      real*8   exisp,etasp,ezeta
      real*8   deriv(ndime,nnodt), heslo(ntens,*), shape(nnodt) 

      nnods=nnodt-nnode
      neres=0
      if(nhess.ne.0) then
        neres=1
        call veczer(ntens*nhess,heslo)
      end if

      call veczer(ndime*nnodt,deriv)

      if(ndime.eq.1) then
        call shape1(exisp,nnode,inint,shape,deriv)
      else if(ndime.eq.2) then
        call shape2(exisp,etasp,nelty,nnode,nnodt,inint,
     .              inpin,inpco,shape,deriv,heslo,neres,
     .              nerep)
      else if(ndime.eq.3) then
        call shape3(exisp,etasp,ezeta,nelty,nnode,nnodt,inint,
     .              inpin,inpco,shape,deriv,heslo,neres,nerep)
      end if

      end
