      subroutine shape1(    s,nnode,inint,shape,deriv)
c***********************************************************************
c
c**** This routine evaluates shape functions and their first derivates 
c**** for 1-d continuos with 2 & 3 nodes
c
c***********************************************************************
      implicit real*8(a-h,o-z)
      real*8 deriv(nnode), shape(nnode)

      if(nnode.eq.2) then     
        shape(1)= 0.5*(1.0-s)
        shape(2)= 0.5*(1.0+s)
        deriv(1)=-0.5
        deriv(2)= 0.5
      else if(nnode.eq.3) then
        if(inint.eq.0) then
          shape(1)= 0.5*s*(s-1.0)
          shape(2)= 0.5*s*(s+1.0)
          shape(3)=-(s+1.0)*(s-1.0)
          deriv(1)= s-0.5
          deriv(2)= s+0.5
          deriv(3)=-2.0*s
        else if(inint.eq.1) then
          shape(1)= 0.5*(1.0-s)
          shape(2)= 0.5*(1.0+s)
          shape(3)=-(s+1.0)*(s-1.0)
          deriv(1)=-0.5
          deriv(2)= 0.5
          deriv(3)=-2.0*s
        end if
      end if

      end
      
