      subroutine pencor(wmatr,cartd,shape,ndime,nnode,nnods,nnodt,
     .                  nevab,nevat,tidiv,penal,zeroc)
c***********************************************************************
c
c**** This routine introduces the terms due to the penalty parameter
c**** in the reidual of the continuity equation and in the perturbation
c**** of the test function      
c
c***********************************************************************
      implicit none
      integer  ndime,nnode,nnods,nnodt,nevab,nevat
      real*8   tidiv,penal,zeroc
      real*8   wmatr(nevat,nevat),     cartd(ndime,nnodt),
     .         shape(nnodt)
      integer  idime,ievab,inode,jnods,jevab,inods,jdime,
     .         jnode
c
c***  Contribution to the top right matrix
c
      do idime=1,ndime
        ievab=idime-ndime
        do inode=1,nnode
          ievab=ievab+ndime
          do jnods = 1,nnods
            jevab = nevab + jnods
            wmatr(ievab,jevab)=wmatr(ievab,jevab)+
     .        tidiv*penal*cartd(idime,inode)*shape(nnode+jnods)
          end do
        end do
      end do
c
c***  Contribution to the bottom matrixes
c
      do inods = 1,nnods
        ievab = nevab + inods
        do jdime = 1,ndime
          jevab = jdime-ndime
          do jnode = 1,nnode
            jevab = jevab+ndime
            wmatr(ievab,jevab)=wmatr(ievab,jevab)+
     .        tidiv*penal*shape(nnode+inods)*cartd(jdime,jnode)
          end do
        end do
        do jnods = 1,nnods
          jevab = nevab + jnods
          wmatr(ievab,jevab)=wmatr(ievab,jevab)+
     .      tidiv*penal*penal*shape(nnode+inods)*shape(nnode+jnods)
        end do
      end do

      end
