      subroutine redihe(cartd,hessi,rtemp,btemp,eltem,alapl,
     .                  ndime,ntens,nnode,naxis,gpcod,difac,
     .                  difol,iethe,thhe1,nhess,kfahe)
c***********************************************************************
c
c**** This routine computes the residual of the temperature equation
c**** due to the diffusive term
c
c***********************************************************************
      implicit none
      integer ndime,ntens,nnode,naxis,iethe,nhess,kfahe,jnode
      real*8  btemp,thhe1,gpcod,difac,difol,xmuit,vecave,vecdot
      real*8  hessi(ntens,nnode),        rtemp(nnode),
     .        eltem(nnode,1+iethe),      alapl(nnode),
     .        cartd(ndime,nnode)

      if (nhess.gt.0) then
        do jnode=1,nnode
          alapl(jnode)=vecave(hessi(1,jnode),ndime)
          if(kfahe.eq.1)
     .      rtemp(jnode)=rtemp(jnode)-difac*alapl(jnode)
        end do
      end if

      if (naxis.eq.1) then
        do jnode=1,nnode
          if (abs(gpcod).ge.1.d-15) then
            xmuit=cartd(1,jnode)/gpcod
          else
            xmuit=0.0d0
            if(nhess.gt.0) xmuit=-hessi(1,jnode)
          end if
          if(kfahe.eq.1) 
     .      rtemp(jnode)=rtemp(jnode)-difac*xmuit
          if (thhe1.le.0.99)
     .      btemp=btemp+difol*xmuit*eltem(jnode,2)
        end do
      end if
      
      if(thhe1.le.0.99) then
        btemp=btemp+difol*vecdot(alapl,eltem(1,2),nnode)
      end if

      end


