      subroutine tanvel(tanve,elvel,tvelo,ndime,nnode)      ! Thinflow
c
c*** Compute the tangential velocity in each nodal point
c
      implicit none
      integer ndime,nnode
      real*8
     .  tanve(ndime,ndime-1,nnode),elvel(ndime,nnode),
     .  tvelo(ndime)

      integer inode,kdime,ldime,mdime

      do inode=1,nnode
        do kdime=1,ndime                                    ! Tangent veloc.
          tvelo(kdime)=0.0d0
          do ldime=1,ndime
            do mdime=1,ndime-1
              tvelo(kdime)=tvelo(kdime)
     .          +tanve(kdime,mdime,inode)
     .          *tanve(ldime,mdime,inode)*elvel(ldime,inode)
            end do
          end do
        end do
        
        do kdime=1,ndime
          elvel(kdime,inode)=tvelo(kdime)
        end do
      end do

      call vecasi(ndime,elvel(22*3-2,1),elvel( 9*3-2,1))
      call vecasi(ndime,elvel(22*3-2,1),elvel(17*3-2,1))
      call vecasi(ndime,elvel(27*3-2,1),elvel(21*3-2,1))
      call vecasi(ndime,elvel(27*3-2,1),elvel(26*3-2,1))
      call vecasi(ndime,elvel(24*3-2,1),elvel(11*3-2,1))
      call vecasi(ndime,elvel(24*3-2,1),elvel(19*3-2,1))
      call vecasi(ndime,elvel(14*3-2,1),elvel( 2*3-2,1))
      call vecasi(ndime,elvel(14*3-2,1),elvel( 6*3-2,1))
      call vecasi(ndime,elvel(23*3-2,1),elvel(10*3-2,1))
      call vecasi(ndime,elvel(23*3-2,1),elvel(18*3-2,1))
      call vecasi(ndime,elvel(15*3-2,1),elvel( 3*3-2,1))
      call vecasi(ndime,elvel(15*3-2,1),elvel( 7*3-2,1))
      call vecasi(ndime,elvel(13*3-2,1),elvel( 1*3-2,1))
      call vecasi(ndime,elvel(13*3-2,1),elvel( 5*3-2,1))
      call vecasi(ndime,elvel(25*3-2,1),elvel(12*3-2,1))
      call vecasi(ndime,elvel(25*3-2,1),elvel(20*3-2,1))
      call vecasi(ndime,elvel(16*3-2,1),elvel( 4*3-2,1))
      call vecasi(ndime,elvel(16*3-2,1),elvel( 8*3-2,1))

      end
