      subroutine temmat(elmat,elrhs,wmatr,wrhsi,shape,rtem1,
     .                  rtem2,btem1,btem2,ptest,timhe,dvoti,
     .                  nnode,kfahe)
c***********************************************************************
c
c**** This routine computes the contribution to the element stiffness
c**** matrix at the current integration point for the heat equation
c
c***********************************************************************
      implicit none
      integer nnode,kfahe,inode,jnode
      real*8  testf,btem1,btem2,timhe,dvoti
      real*8  elmat(nnode,nnode),     elrhs(nnode),
     .        wmatr(nnode,nnode),     wrhsi(nnode),
     .        shape(nnode),           rtem1(nnode),
     .        rtem2(nnode),           ptest(nnode)

      do inode=1,nnode
        testf=shape(inode)+ptest(inode)
        elrhs(inode)=elrhs(inode)+dvoti*
     .    (wrhsi(inode)+testf*btem1+ptest(inode)*btem2)
        if(kfahe.eq.1) then
          do jnode=1,nnode
            elmat(inode,jnode)=elmat(inode,jnode)+dvoti*
     .        (wmatr(inode,jnode)+
     .        testf*rtem1(jnode)+ptest(inode)*rtem2(jnode))
          end do
        end if
      end do

      end
