      subroutine pscelm(shape,elmat,elrhs,elvel,elfrs,tanve,cartd, ! Thinflow
     .                  dvolu,tragl,hleng,grpsc,veloc,chave,ptest)
c*****************************************************************
c
c**** This routine computes the element matrix and rhs for the
c**** pseudo-concentration equation 
c
c*****************************************************************
      implicit none
      include 'com_prob.f'
      include 'com_auxi.f'
      real*8  timpc,chale
      real*8  shape(nnodt,ngaus),    cartd(ndime,nnodt,ngaus),  
     .        dvolu(ngaus),          tragl(ndime,ndime),
     .        hleng(ndime),          elmat(nnode,nnode),
     .        elrhs(nnode),          elvel(ndime*nnode,1+ietns),
     .        elfrs(nnode,1+ietfs),  tanve(ndime,ndime-1,nnode,nelem) !Thinflow
      real*8  grpsc(ndime),          veloc(ndime),
     .        chave(ndime,2),        ptest(nnode)

      if (nnode.eq.27 .and. nnods.eq.3)                     ! Thinflow
     .  call tanvel(                                        ! Tangent velocity
     .  tanve(1,1,1,ielem),elvel,veloc,ndime,nnode)
c
c*** Computes the characteristic element length, if needed
c
      if (klspc.eq.1)
     . call pscvst(tragl,hleng,elvel,chave,chale,ndime,
     .             nnode,hnatu)
c
c*** Main integration loop
c
      if(kfapc.eq.1) call veczer(nnode*nnode,elmat)
      call veczer(nnode      ,elrhs)
      timpc=0.0
      do igaus=1,ngaus
        call veczer(nnode,ptest)
        call pscvsg(shape(1,igaus),elvel,chave,chale,ndime,
     .              nnode,lspcc,sfpcc,timpc)
        call psctes(cartd(1,1,igaus),chave,ptest,lspcc,
     .              ndime,nnode,timpc,elvel,shape(1,igaus),nevab)
        call psctot(elmat,elrhs,shape(1,igaus),cartd(1,1,igaus),
     .              ptest,dvolu(igaus),elvel,elfrs,tstep,thpc1,
     .              ietfs,itwfs,veloc,grpsc,fpara,ndime,nnode,
     .              1+ietns,kfapc)
      end do

      end
