      subroutine finish(iffix,lnods,coord,veloc,presu,tempe,fresu,
     .                  shape,elpro,work1)
c***********************************************************************
c
c**** This routine ends the time step properly
c
c***********************************************************************
      implicit none
      include 'com_prob.f'
      include 'com_auxi.f'
      include 'def_logi.f'
      integer    kstst,itotv,ipoin,idime,kauxi,n_write
      logical*1  wellf
      integer    iffix(nvfix),       lnods(nnodt,nelem)
      real*8     coord(ndime,npoin), veloc(ntotv,ncove),
     .           presu(ntotp,ncopr), tempe(npoin,ncote),
     .           fresu(npoin,ncofs), shape(nnodt,ngaus),
     .           elpro(nprod,ngaus,nelem), work1(*)
c
c*** Checks if steady-state has been reached
c
      kstst=0
      if(ietns+iethe+ietfs.ne.0)
     .  call steace(veloc,tempe,fresu,kstst)
c
c*** Write velocities and pseudo_concentrations for pipeline
c
      n_write=6
      if(lwrvp.eq.1) then
        itotv=0
        do ipoin=1,npoin
          do idime=1,ndime
            itotv=itotv+1
            write(*,'(e17.8)') veloc(itotv,1)
          end do
        end do
        do ipoin=1,npoin
          write(*,'(e17.8)') fresu(ipoin,1)
        end do
        kauxi=0
        if((tactu.ge.tfina).or.(kstst.eq.1).or.(nchek.ne.0)) then
          kauxi=1
          lwrvp=2
        end if
        write(*,*) kauxi
      end if
c
c*** Output results
c
      call output(iffix,lnods,coord,veloc,presu,tempe,fresu,
     .            shape,elpro,kstst,work1(ismoe(1)),
     .            work1(ismoe(2)),work1)
c
c*** End of step
c
      write(lulog,900)
c
c*** Writes the results to a file to be used for a re-start
c
      if((nchek.eq.0).and.(tactu.ge.tfina).and.(preli)) then
        wellf=.true.
        call outrst(veloc,presu,tempe,fresu,
     .    %val(tkine_p),%val(tener_p),%val(cletu_p),%val(visct_p),
     .    elpro,wellf)
      end if
c
c*** Formats
c
  900 FORMAT(50X,'>>>>>>> END OF STEP',/)

      end
