      subroutine outmec(work1,presu,lnods,iwork)
c***********************************************************************
c
c****This routine writes pressure & vorticity to output and 
c    postprocessor files
c
c***********************************************************************
      implicit real*8(a-h,o-z)
      include 'com_prob.f'
      include 'com_auxi.f'
      include 'com_inou.f'
      include 'def_logi.f'
      integer      lnods(nnodt,nelem), iwork(npoin)
      real*8       work1(2*npoin),     presu(ntotp)
      character*5  wopos

      if(kposc(2).eq.1) then
        if (nnode.eq.nnods) call vecasi(ntotp,presu,work1)
        wopos='PRESS'
        write(lupos) wopos
        write(lupos) istep,tactu,
     .               (work1(itotv),itotv=1,npoin)
      end if
      if(kposc(4).eq.1) then
        wopos='VORTI'
        write(lupos) wopos
        write(lupos) istep,tactu,
     .               (work1(itotv),itotv=npoin+1,2*npoin)
      end if

      if(kpric(2).eq.0.and.kpric(4).eq.0) return

      write(lures,915)
      if(kpric(2).eq.1.and.kpric(4).eq.1) then
        write(lures,920)
        do ipoin=1,npoin
          write(lures,905) ipoin,work1(ipoin),work1(npoin+ipoin)
        end do
      else if(kpric(2).eq.0.and.kpric(4).eq.1) then
        write(lures,925)
        do ipoin=1,npoin
          write(lures,906) ipoin,work1(npoin+ipoin)
        end do
      else if(kpric(2).eq.1.and.kpric(4).eq.0) then
        write(lures,930)
        do ipoin=1,npoin
          write(lures,907) ipoin,work1(ipoin)
        end do
      end if

  905 FORMAT(5X,I5,2E15.6)
  906 FORMAT(5X,I5,15X,E15.6)
  907 FORMAT(5X,I5,E15.6)
  915 FORMAT(//,5X,'NODAL PRESSURES AND/OR VORTICITIES',
     .        /,5X,'----------------------------------')
  920 FORMAT(/,5X,' NODE',7X,'PRESSURE',6X,'VORTICITY')
  925 FORMAT(/,5X,' NODE',7X,'        ',6X,'VORTICITY')
  930 FORMAT(/,5X,' NODE',7X,'PRESSURE',6X,'         ')

      end
