      subroutine outten(work1)
c***********************************************************************
c
c****This routine writes stresses to output and 
c    postprocessor files
c
c***********************************************************************
      implicit real*8(a-h,o-z)
      include 'com_prob.f'
      include 'com_auxi.f'
      include 'com_inou.f'
      include 'def_logi.f'
      real*8       work1(ntens*npoin)
      character*5  wopos

      if(kposc(3).eq.1) then
        wopos='STRES'
        write(lupos) wopos
        write(lupos) istep,tactu,
     .               (work1(itotv),itotv=1,ntens*npoin)
      end if

      if(kpric(3).eq.0) return

      write(lures,915)
      if(ndime.eq.2) then
        write(lures,920)
        do ipoin=1,npoin
          write(lures,905) ipoin,work1(ipoin),work1(npoin+ipoin),
     .                           work1(2*npoin+ipoin)
        end do
      else
        write(lures,925)
        do ipoin=1,npoin
          write(lures,905) ipoin,work1(ipoin),work1(npoin+ipoin),
     .                     work1(2*npoin+ipoin),work1(3*npoin+ipoin),
     .                     work1(4*npoin+ipoin),work1(5*npoin+ipoin)
        end do
      end if

  905 FORMAT(5X,I5,6E15.6)
  915 FORMAT(//,5X,'NODAL STRESSES',
     .        /,5X,'--------------')
  920 FORMAT(/,5X,' NODE',7X,'STRES_11',6X,'STRES_22',6X,'STRES_12')
  925 FORMAT(/,5X,' NODE',7X,'STRES_11',6X,'STRES_22',6X,'STRES_12',6X,
     .                       'STRES_33',6X,'STRES_13',6X,'STRES_23')

      end
