      subroutine upvist(tkine,cletu,visct,npoin,turbu)
c*************************************************************************
c  
c**** This routine updates the turbulent viscosity according to the 
c**** turbulence model being used
c
c*************************************************************************
      implicit none
      integer   npoin,ipoin
      real*8    cletu(npoin),  tkine(npoin),  visct(npoin),  turbu(1)

c
c*** K-E model: nu_t = c_u K^(2.0)/E = K^(0.5)*L
c
      do ipoin=1,npoin
        visct(ipoin)=sqrt(tkine(ipoin))*cletu(ipoin)
      end do

      end
