      subroutine cosube(lnodw)
c***********************************************************************
c
c**** This routine constructs the nodal connections of the linear
c**** subelements of each element
c
c***********************************************************************
      implicit none
      include 'com_prob.f'
      include 'com_auxi.f'
      integer   istop,isubn,isube
      real*8    time1,time2
      integer   lnodw(nsubn,nsube)

      call cputim(time1)
c
c*** Nodal connections
c
      istop=0
      isube=0
      if(ndime.eq.2) then
        if(nelty.eq.1) then
          if(nnode.eq.4) then
            isube = isube+1
            lnodw(1,isube) =1
            lnodw(2,isube) =2
            lnodw(3,isube) =3
            isube = isube+1
            lnodw(1,isube) =1
            lnodw(2,isube) =3
            lnodw(3,isube) =4
          else if(nnode.eq.5) then
            isube = isube+1
            lnodw(1,isube) =1
            lnodw(2,isube) =2
            lnodw(3,isube) =5
            isube = isube+1
            lnodw(1,isube) =2
            lnodw(2,isube) =3
            lnodw(3,isube) =5
            isube = isube+1
            lnodw(1,isube) =3
            lnodw(2,isube) =4
            lnodw(3,isube) =5
            isube = isube+1
            lnodw(1,isube) =4
            lnodw(2,isube) =1
            lnodw(3,isube) =5
          else if(nnode.eq.9) then
            isube = isube+1
            lnodw(1,isube) =1
            lnodw(2,isube) =5
            lnodw(3,isube) =9
            isube = isube+1  
            lnodw(1,isube) =5
            lnodw(2,isube) =2
            lnodw(3,isube) =9
            isube = isube+1  
            lnodw(1,isube) =2
            lnodw(2,isube) =6
            lnodw(3,isube) =9
            isube = isube+1  
            lnodw(1,isube) =6
            lnodw(2,isube) =3
            lnodw(3,isube) =9
            isube = isube+1
            lnodw(1,isube) =3
            lnodw(2,isube) =7
            lnodw(3,isube) =9
            isube = isube+1  
            lnodw(1,isube) =7
            lnodw(2,isube) =4
            lnodw(3,isube) =9
            isube = isube+1  
            lnodw(1,isube) =4
            lnodw(2,isube) =8
            lnodw(3,isube) =9
            isube = isube+1  
            lnodw(1,isube) =8
            lnodw(2,isube) =1
            lnodw(3,isube) =9
          else
            istop=1
          end if
        else if(nelty.eq.2) then
          if(nnode.eq.3) then
            do isubn=1,nsubn
              lnodw(isubn,1)=isubn
            end do
          else if (nnode.eq.4) then
            isube=isube+1
            lnodw(1,isube) =1
            lnodw(2,isube) =4
            lnodw(3,isube) =3
            isube=isube+1
            lnodw(1,isube) =1
            lnodw(2,isube) =2
            lnodw(3,isube) =4
            isube=isube+1
            lnodw(1,isube) =2
            lnodw(2,isube) =3
            lnodw(3,isube) =4
          else if(nnode.eq.6) then
            isube = isube+1
            lnodw(1,isube) =1
            lnodw(2,isube) =4
            lnodw(3,isube) =6
            isube = isube+1  
            lnodw(1,isube) =4
            lnodw(2,isube) =5
            lnodw(3,isube) =6
            isube = isube+1  
            lnodw(1,isube) =4
            lnodw(2,isube) =2
            lnodw(3,isube) =5
            isube = isube+1  
            lnodw(1,isube) =6
            lnodw(2,isube) =5
            lnodw(3,isube) =3
          else if(nnode.eq.7) then
            isube = isube+1
            lnodw(1,isube) =1
            lnodw(2,isube) =4
            lnodw(3,isube) =7
            isube = isube+1  
            lnodw(1,isube) =4
            lnodw(2,isube) =2
            lnodw(3,isube) =7
            isube = isube+1  
            lnodw(1,isube) =2
            lnodw(2,isube) =5
            lnodw(3,isube) =7
            isube = isube+1
            lnodw(1,isube) =3
            lnodw(2,isube) =6
            lnodw(3,isube) =7
            isube = isube+1  
            lnodw(1,isube) =5
            lnodw(2,isube) =3
            lnodw(3,isube) =7
            isube = isube+1  
            lnodw(1,isube) =6
            lnodw(2,isube) =1
            lnodw(3,isube) =7
          else
            istop=1
          end if
        end if
      else if(ndime.eq.3) then
        if(nelty.eq.1) then
          if(nnode.eq.8) then
            isube = isube+1
            lnodw(1,isube) =1
            lnodw(2,isube) =3
            lnodw(3,isube) =6
            lnodw(4,isube) =2
            isube = isube+1  
            lnodw(1,isube) =6
            lnodw(2,isube) =3
            lnodw(3,isube) =8
            lnodw(4,isube) =7
            isube = isube+1  
            lnodw(1,isube) =1
            lnodw(2,isube) =6
            lnodw(3,isube) =8
            lnodw(4,isube) =5
            isube = isube+1  
            lnodw(1,isube) =4
            lnodw(2,isube) =8
            lnodw(3,isube) =1
            lnodw(4,isube) =3
            isube = isube+1  
            lnodw(1,isube) =1
            lnodw(2,isube) =3
            lnodw(3,isube) =8
            lnodw(4,isube) =6
          else if(nnode.eq.27) then
c
c*** First cube
c           
            isube = isube+1
            lnodw(1,isube) =1
            lnodw(2,isube) =21
            lnodw(3,isube) =22
            lnodw(4,isube) =9
            isube = isube+1  
            lnodw(1,isube) =22
            lnodw(2,isube) =21
            lnodw(3,isube) =25
            lnodw(4,isube) =27
            isube = isube+1  
            lnodw(1,isube) =1
            lnodw(2,isube) =22
            lnodw(3,isube) =25
            lnodw(4,isube) =13
            isube = isube+1  
            lnodw(1,isube) =12
            lnodw(2,isube) =25
            lnodw(3,isube) =1
            lnodw(4,isube) =21
            isube = isube+1  
            lnodw(1,isube) =1
            lnodw(2,isube) =21
            lnodw(3,isube) =25
            lnodw(4,isube) =22
c
c*** Second cube
c
            isube = isube+1
            lnodw(1,isube) =9
            lnodw(2,isube) =10
            lnodw(3,isube) =14
            lnodw(4,isube) =2
            isube = isube+1  
            lnodw(1,isube) =14
            lnodw(2,isube) =10
            lnodw(3,isube) =27
            lnodw(4,isube) =23
            isube = isube+1  
            lnodw(1,isube) =9
            lnodw(2,isube) =14
            lnodw(3,isube) =27
            lnodw(4,isube) =22
            isube = isube+1  
            lnodw(1,isube) =21
            lnodw(2,isube) =27
            lnodw(3,isube) =9
            lnodw(4,isube) =10
            isube = isube+1  
            lnodw(1,isube) =9
            lnodw(2,isube) =10
            lnodw(3,isube) =27
            lnodw(4,isube) =14
c
c*** Third cube
c
            isube = isube+1
            lnodw(1,isube) =21
            lnodw(2,isube) =3
            lnodw(3,isube) =23
            lnodw(4,isube) =10
            isube = isube+1  
            lnodw(1,isube) =23
            lnodw(2,isube) =3
            lnodw(3,isube) =24
            lnodw(4,isube) =15
            isube = isube+1  
            lnodw(1,isube) =21
            lnodw(2,isube) =23
            lnodw(3,isube) =24
            lnodw(4,isube) =27
            isube = isube+1  
            lnodw(1,isube) =4
            lnodw(2,isube) =16
            lnodw(3,isube) =21
            lnodw(4,isube) =3
            isube = isube+1  
            lnodw(1,isube) =21
            lnodw(2,isube) =3
            lnodw(3,isube) =24
            lnodw(4,isube) =23            
c
c*** Fourth cube
c
            isube = isube+1
            lnodw(1,isube) =12
            lnodw(2,isube) =11
            lnodw(3,isube) =27
            lnodw(4,isube) =21
            isube = isube+1  
            lnodw(1,isube) =27
            lnodw(2,isube) =11
            lnodw(3,isube) =16
            lnodw(4,isube) =24
            isube = isube+1  
            lnodw(1,isube) =12
            lnodw(2,isube) =27
            lnodw(3,isube) =16
            lnodw(4,isube) =25
            isube = isube+1  
            lnodw(1,isube) =4
            lnodw(2,isube) =16
            lnodw(3,isube) =12
            lnodw(4,isube) =11
            isube = isube+1  
            lnodw(1,isube) =12
            lnodw(2,isube) =11
            lnodw(3,isube) =16
            lnodw(4,isube) =27
c
c*** Fifth cube
c
            isube = isube+1
            lnodw(1,isube) =13
            lnodw(2,isube) =27
            lnodw(3,isube) =17
            lnodw(4,isube) =22
            isube = isube+1  
            lnodw(1,isube) =17
            lnodw(2,isube) =27
            lnodw(3,isube) =20
            lnodw(4,isube) =26
            isube = isube+1  
            lnodw(1,isube) =13
            lnodw(2,isube) =17
            lnodw(3,isube) =20
            lnodw(4,isube) =5
            isube = isube+1  
            lnodw(1,isube) =25
            lnodw(2,isube) =20
            lnodw(3,isube) =13
            lnodw(4,isube) =27
            isube = isube+1  
            lnodw(1,isube) =13
            lnodw(2,isube) =27
            lnodw(3,isube) =20
            lnodw(4,isube) =17
c
c*** Sixth cube
c
            isube = isube+1
            lnodw(1,isube) =22
            lnodw(2,isube) =13
            lnodw(3,isube) =6
            lnodw(4,isube) =14
            isube = isube+1  
            lnodw(1,isube) =6
            lnodw(2,isube) =13
            lnodw(3,isube) =16
            lnodw(4,isube) =18
            isube = isube+1  
            lnodw(1,isube) =22
            lnodw(2,isube) =6
            lnodw(3,isube) =16
            lnodw(4,isube) =17
            isube = isube+1  
            lnodw(1,isube) =27
            lnodw(2,isube) =16
            lnodw(3,isube) =22
            lnodw(4,isube) =13
            isube = isube+1  
            lnodw(1,isube) =22
            lnodw(2,isube) =13
            lnodw(3,isube) =16
            lnodw(4,isube) =6
c
c*** Seventh cube
c
            isube = isube+1
            lnodw(1,isube) =27
            lnodw(2,isube) =15
            lnodw(3,isube) =18
            lnodw(4,isube) =23
            isube = isube+1  
            lnodw(1,isube) =18
            lnodw(2,isube) =15
            lnodw(3,isube) =19
            lnodw(4,isube) =7
            isube = isube+1  
            lnodw(1,isube) =27
            lnodw(2,isube) =18
            lnodw(3,isube) =19
            lnodw(4,isube) =26
            isube = isube+1  
            lnodw(1,isube) =24
            lnodw(2,isube) =19
            lnodw(3,isube) =27
            lnodw(4,isube) =15
            isube = isube+1  
            lnodw(1,isube) =27
            lnodw(2,isube) =15
            lnodw(3,isube) =19
            lnodw(4,isube) =18
c
c*** Eighth cube
c
            isube = isube+1
            lnodw(1,isube) =25
            lnodw(2,isube) =24
            lnodw(3,isube) =26
            lnodw(4,isube) =27
            isube = isube+1  
            lnodw(1,isube) =26
            lnodw(2,isube) =24
            lnodw(3,isube) =8
            lnodw(4,isube) =19
            isube = isube+1  
            lnodw(1,isube) =25
            lnodw(2,isube) =26
            lnodw(3,isube) =8
            lnodw(4,isube) =20
            isube = isube+1  
            lnodw(1,isube) =16
            lnodw(2,isube) =8
            lnodw(3,isube) =25
            lnodw(4,isube) =24
            isube = isube+1  
            lnodw(1,isube) =25
            lnodw(2,isube) =24
            lnodw(3,isube) =8
            lnodw(4,isube) =26            
          else
            istop=1
          end if
        else if(nelty.eq.2) then
          if(nnode.eq.4) then
            do isubn=1,nsubn
              lnodw(isubn,1)=isubn
            end do
          else if(nnode.eq.5) then
            isube = isube+1
            lnodw(1,isube) = 1 
            lnodw(2,isube) = 2           
            lnodw(3,isube) = 3 
            lnodw(4,isube) = 5
            isube = isube+1
            lnodw(1,isube) = 1 
            lnodw(2,isube) = 4           
            lnodw(3,isube) = 2 
            lnodw(4,isube) = 5
            isube = isube+1
            lnodw(1,isube) = 2 
            lnodw(2,isube) = 4           
            lnodw(3,isube) = 3 
            lnodw(4,isube) = 5
            isube = isube+1
            lnodw(1,isube) = 3 
            lnodw(2,isube) = 4           
            lnodw(3,isube) = 1 
            lnodw(4,isube) = 5
          else if(nnode.eq.10) then
            isube = isube+1
            lnodw(1,isube) = 1 
            lnodw(2,isube) = 5           
            lnodw(3,isube) = 7 
            lnodw(4,isube) = 8
            isube = isube+1
            lnodw(1,isube) = 5 
            lnodw(2,isube) = 9          
            lnodw(3,isube) = 7
            lnodw(4,isube) = 8
            isube = isube+1
            lnodw(1,isube) = 5 
            lnodw(2,isube) = 2          
            lnodw(3,isube) = 6
            lnodw(4,isube) = 9
            isube = isube+1
            lnodw(1,isube) = 6 
            lnodw(2,isube) =10          
            lnodw(3,isube) = 9
            lnodw(4,isube) = 7
            isube = isube+1
            lnodw(1,isube) = 6 
            lnodw(2,isube) = 3          
            lnodw(3,isube) = 7
            lnodw(4,isube) =10
            isube = isube+1
            lnodw(1,isube) =10
            lnodw(2,isube) = 9          
            lnodw(3,isube) = 8
            lnodw(4,isube) = 7
            isube = isube+1
            lnodw(1,isube) = 5
            lnodw(2,isube) = 6          
            lnodw(3,isube) = 7
            lnodw(4,isube) = 9
            isube = isube+1
            lnodw(1,isube) = 9
            lnodw(2,isube) =10          
            lnodw(3,isube) = 8
            lnodw(4,isube) = 4
          else if(nnode.eq.15) then
c
c*** First cube
c
            isube = isube+1
            lnodw(1,isube) =1
            lnodw(2,isube) =11
            lnodw(3,isube) =12
            lnodw(4,isube) =5
            isube = isube+1  
            lnodw(1,isube) =12
            lnodw(2,isube) =11
            lnodw(3,isube) =14
            lnodw(4,isube) =15
            isube = isube+1  
            lnodw(1,isube) =1
            lnodw(2,isube) =12
            lnodw(3,isube) =14
            lnodw(4,isube) =8
            isube = isube+1  
            lnodw(1,isube) =7
            lnodw(2,isube) =14
            lnodw(3,isube) =1
            lnodw(4,isube) =11
            isube = isube+1  
            lnodw(1,isube) =1
            lnodw(2,isube) =11
            lnodw(3,isube) =14
            lnodw(4,isube) =12
c
c*** Second cube
c
            isube = isube+1
            lnodw(1,isube) =5
            lnodw(2,isube) =6
            lnodw(3,isube) =9
            lnodw(4,isube) =2
            isube = isube+1  
            lnodw(1,isube) =9
            lnodw(2,isube) =6
            lnodw(3,isube) =15
            lnodw(4,isube) =13
            isube = isube+1  
            lnodw(1,isube) =5
            lnodw(2,isube) =9
            lnodw(3,isube) =15
            lnodw(4,isube) =12
            isube = isube+1  
            lnodw(1,isube) =11
            lnodw(2,isube) =15
            lnodw(3,isube) =5
            lnodw(4,isube) =6
            isube = isube+1  
            lnodw(1,isube) =5
            lnodw(2,isube) =6
            lnodw(3,isube) =15
            lnodw(4,isube) =9
c
c*** Third cube
c
            isube = isube+1
            lnodw(1,isube) =7
            lnodw(2,isube) =6
            lnodw(3,isube) =15
            lnodw(4,isube) =11
            isube = isube+1  
            lnodw(1,isube) =15
            lnodw(2,isube) =6
            lnodw(3,isube) =10
            lnodw(4,isube) =13
            isube = isube+1  
            lnodw(1,isube) =7
            lnodw(2,isube) =15
            lnodw(3,isube) =10
            lnodw(4,isube) =14
            isube = isube+1  
            lnodw(1,isube) =3
            lnodw(2,isube) =10
            lnodw(3,isube) =7
            lnodw(4,isube) =6
            isube = isube+1  
            lnodw(1,isube) =7
            lnodw(2,isube) =6
            lnodw(3,isube) =10
            lnodw(4,isube) =15
c
c*** Fourth cube
c
            isube = isube+1
            lnodw(1,isube) =8
            lnodw(2,isube) =15
            lnodw(3,isube) =9
            lnodw(4,isube) =12
            isube = isube+1  
            lnodw(1,isube) =9
            lnodw(2,isube) =15
            lnodw(3,isube) =10
            lnodw(4,isube) =13
            isube = isube+1  
            lnodw(1,isube) =8
            lnodw(2,isube) =9
            lnodw(3,isube) =10
            lnodw(4,isube) =4
            isube = isube+1  
            lnodw(1,isube) =14
            lnodw(2,isube) =10
            lnodw(3,isube) =8
            lnodw(4,isube) =15
            isube = isube+1  
            lnodw(1,isube) =8
            lnodw(2,isube) =15
            lnodw(3,isube) =10
            lnodw(4,isube) =9            
          else
            istop=1
          end if
        end if
      end if
c
c*** Stops the program if the element to be used is not programmed
c
      if(istop.eq.1)
     .  call runend('COSUBE: SMOOTHING NOT READY FOR THIS ELEMENT')

      call cputim(time2)
      cpust=cpust+(time2-time1)

      end
