      subroutine dumpgm(coord,lnods,lpoty,lroty,exnor,skcos,exwor)
c***********************************************************************
c
c**** This routine dumps the geometric model for postprocess
c
c***********************************************************************
      implicit none
      include 'com_prob.f'
      include 'com_auxi.f'
      include 'com_inou.f'
      include 'def_logi.f'
      integer   lnods(nnodt,nelem), lpoty(npoin), lroty(nbopo)
      real*8    coord(ndime,npoin), exnor(ndime,ndime,nbopo),
     .          exwor(ndime*npoin), skcos(ndime,ndime,nfaco)
      integer   dummi,i,j
      real*8    time1,time2
      
      call cputim(time1)
      if (kpost.ne.0) then
c
c*** Write control data for postprocessor
c
        call opendk(    0,lupos)
        if (.not.rstar) then
          write(lupos) ndime,nnode,nelty,nelem,npoin,iephe,title
c
c*** Write geometry for postprocessor
c
          write(lupos) ((coord(i,j),i=1,ndime),j=1,npoin),
     .                 ((lnods(i,j),i=1,nnode),j=1,nelem)
c
c*** To write the external normals, use the lines commented out with C-N
c
c-n       call veczer(ndime*npoin,exwor)
c-n       do ipoin=1,npoin
c-n         ibopo=lpoty(ipoin)
c-n         if (ibopo.ne.0) then
c-n           itotn=(ipoin-1)*ndime
c-n           do idime=1,ndime
c-n             itotn=itotn+1
c-n             exwor(itotn)=exnor(idime,1,ibopo)
c-n           end do
c-n         end if
c-n       end do
c-n       write(lupos) 'EXNOR'
c-n       dummi=1
c-n       write(lupos) dummi,tinit+tstep,
c-n  .                (exwor(itotn),itotn=1,ndime*npoin)
c
c*** To write the first vector of the local basis when it exists and the
c*** normal when it does not, use the lines commented out with C-L
c
c-l       if (nfaco.ge.1) then
c-l         call veczer(ndime*npoin,exwor)
c-l         do ipoin=1,npoin
c-l           ibopo=lpoty(ipoin)
c-l           if (ibopo.ne.0) then
c-l             ifaco=lroty(ibopo)-1
c-l             if (ifaco.gt.0) then
c-l               itotn=(ipoin-1)*ndime
c-l               do idime=1,ndime
c-l                 itotn=itotn+1
c-l                 exwor(itotn)=skcos(idime,1,ifaco)
c-l               end do
c-l             end if
c-l           end if
c-l         end do
c-l         write(lupos) 'EXNOR'
c-l         dummi=2
c-l         write(lupos) dummi,tinit+2.0d0*tstep,
c-l  .                  (exwor(itotn),itotn=1,ndime*npoin)
c-l       end if
        end if
        close(lupos,status='keep')
      end if

      call cputim(time2)
      cpust=cpust+(time2-time1)
      
      end
