      subroutine exno10(lnods,exwor)
c*************************************************************************
c
c**** This routine computes the vector of exterior normals for the corner
c**** nodes of the 10 node tetrahedron 
c
c*************************************************************************
      implicit none
      include 'com_prob.f'
      include 'com_auxi.f'
      integer   idime
      integer   lnods(nnodt,nelem)
      real*8
     .  xnorm,exl05,exl06,exl07,exl08,exl09,
     .  exl10,ssuma
      real*8    exwor(ndime,npoin)

      if((nelty.eq.2).and.(nnode.eq.10).and.(ndime.eq.3)) then
        do ielem=1,nelem
          do idime=1,ndime                                  
            exl05=exl05+exwor(idime,lnods( 5,ielem))**2
            exl06=exl06+exwor(idime,lnods( 6,ielem))**2            
            exl07=exl07+exwor(idime,lnods( 7,ielem))**2            
            exl08=exl08+exwor(idime,lnods( 8,ielem))**2
            exl09=exl09+exwor(idime,lnods( 9,ielem))**2
            exl10=exl10+exwor(idime,lnods(10,ielem))**2
          end do
          if(exl07.gt.1.0e-6.and.exl08.gt.1.0e-6.
     .      and.exl10.gt.1.0e-6) then
            do idime=1,ndime
              ssuma=exwor(idime,lnods( 7,ielem))
     .             +exwor(idime,lnods( 8,ielem))
     .             +exwor(idime,lnods(10,ielem))
              exwor(idime,lnods(1,ielem))=
     .          exwor(idime,lnods(1,ielem))
     .          +ssuma
              exwor(idime,lnods(3,ielem))=
     .          exwor(idime,lnods(3,ielem))
     .          +ssuma
              exwor(idime,lnods(4,ielem))=
     .          exwor(idime,lnods(4,ielem))
     .          +ssuma
            end do
          end if
          if(exl07.gt.1.0e-6.and.exl06.gt.1.0e-6.
     .      and.exl05.gt.1.0e-6) then
            do idime=1,ndime
              ssuma=exwor(idime,lnods( 7,ielem))
     .             +exwor(idime,lnods( 6,ielem))
     .             +exwor(idime,lnods( 5,ielem))
              exwor(idime,lnods(1,ielem))=
     .          exwor(idime,lnods(1,ielem))
     .          +ssuma
              exwor(idime,lnods(2,ielem))=
     .          exwor(idime,lnods(2,ielem))
     .          +ssuma
              exwor(idime,lnods(3,ielem))=
     .          exwor(idime,lnods(3,ielem))
     .          +ssuma
            end do
          end if
          if(exl06.gt.1.0e-6.and.exl09.gt.1.0e-6.
     .      and.exl10.gt.1.0e-6) then
            do idime=1,ndime
              ssuma=exwor(idime,lnods( 6,ielem))
     .             +exwor(idime,lnods( 9,ielem))
     .             +exwor(idime,lnods(10,ielem))
              exwor(idime,lnods(2,ielem))=
     .          exwor(idime,lnods(2,ielem))
     .          +ssuma
              exwor(idime,lnods(3,ielem))=
     .          exwor(idime,lnods(3,ielem))
     .          +ssuma
              exwor(idime,lnods(4,ielem))=
     .          exwor(idime,lnods(4,ielem))
     .          +ssuma
            end do
          end if
          if(exl05.gt.1.0e-6.and.exl08.gt.1.0e-6.
     .      and.exl09.gt.1.0e-6) then
            do idime=1,ndime
              ssuma=exwor(idime,lnods( 5,ielem))
     .             +exwor(idime,lnods( 8,ielem))
     .             +exwor(idime,lnods( 9,ielem))
              exwor(idime,lnods(1,ielem))=
     .          exwor(idime,lnods(1,ielem))
     .          +ssuma
              exwor(idime,lnods(2,ielem))=
     .          exwor(idime,lnods(2,ielem))
     .          +ssuma
              exwor(idime,lnods(4,ielem))=
     .          exwor(idime,lnods(4,ielem))
     .          +ssuma
            end do
          end if
        end do
      end if    

      end
