      subroutine inival(iffix,lnods,veloc,presu,tempe,fresu,presc,
     .                  iwork,work1)
c**********************************************************************
c
c**** This routine stores initial values for the main variables
c
c**********************************************************************
      implicit real*8(a-h,o-z)
      include 'com_prob.f'
      include 'com_auxi.f'
      integer   lnods(nnodt,nelem), iwork(npoin), iffix(nvfix)
      integer   itot2
      real*8    time1,time2
      real*8    veloc(ntotv,ncove), presu(ntotp,ncopr),
     .          tempe(npoin,ncote), fresu(npoin,ncofs), 
     .          presc(nltot),       work1(*)

      call cputim(time1)
c
c*** Rotates prescriptions from local to global axes
c
      call vecasi(ntotv,presc,%val(presv_p))
      if(kerot.eq.1.or.keima.gt.0) 
     .  call velmod(iffix,%val(lpoty_p),%val(lroty_p),%val(skcos_p),
     .              %val(exnor_p),presc,%val(presv_p),
     .              presc(ntotv+iephe*npoin+1),work1,0)
c
c*** Initializes velocities and pressures
c
      call veczer(ntotv*ncove,veloc)
      call veczer(ntotp*ncopr,presu)
c
c*** Initializes the time step counter and the actual time
c
      istep=0
      tactu=tinit
c
c*** Stores initial velocities
c
      if(iupns.eq.1) then
        if (inint.eq.1) call sttohi(presc,lnods,ndime,npoin,nnode,
     .                              nelem,nnodt,nelty,ndime,iwork)
        do idime=1,ndime
          do ipoin=1,npoin
            itotv=(ipoin-1)*ndime+idime
            veloc(itotv,1)=presc(itotv)
            if(iepns.eq.1) veloc(itotv,2)=presc(itotv)
            if(ietns.ge.1) then
              itot2=itotv+iuphe*npoin
     .                   +iupfs*npoin
     .                   +ietns*ntotv              
              if(iffix(itot2).eq.5) then
                iffix(itot2)=0
                veloc(itotv,2)=presc(itot2)
              end if
            end if
          end do
        end do
      end if
c
c*** Stores initial temperatures
c
      if(iuphe.eq.1) then
        itotv=iupns*ntotv+1
        if (inint.eq.1)
     .    call sttohi(presc(itotv),lnods, 1,npoin,nnode,
     .                nelem,nnodt,nelty,ndime,iwork)
        call upslav(%val(lpoty_p),%val(lroty_p),presc(itotv))
        itotv=itotv-1
        do ipoin=1,npoin
          itotv=itotv+1
          tempe(ipoin,1)=presc(itotv)
          if(iephe.eq.1) tempe(ipoin,2)=presc(itotv)
        end do
      end if
c
c*** Stores initial position of the free surface
c
      if(iupfs.eq.1) then
        itotv=iupns*ntotv+iuphe*npoin+1
        if (inint.eq.1)
     .    call sttohi(presc(itotv),lnods, 1,npoin,nnode,
     .                nelem,nnodt,nelty,ndime,iwork)
        call upslav(%val(lpoty_p),%val(lroty_p),presc(itotv))
        itotv=itotv-1
        do ipoin=1,npoin
          itotv=itotv+1
          fresu(ipoin,1)=presc(itotv)
          if(iepfs.eq.1) fresu(ipoin,2)=presc(itotv)
        end do
      end if

      call cputim(time2)
      cpust=cpust+(time2-time1)
      
      end
