      subroutine dtcrit(veloc)
c***********************************************************************
c
c**** This routine computes the time step size when the convective
c**** term of the Navier-Stokes equations is treated explicitly      
c
c***********************************************************************
      implicit none
      include 'com_prob.f'
      include 'com_auxi.f'
      integer  itotv,ipoin,idime
      real*8   venor
      real*8   veloc(ntotv,ncove)

      tstep=1.0d0/zero2
      itotv=0
      do ipoin=1,npoin
        venor=0.0d0
        do idime=1,ndime
          itotv=itotv+1
          venor=venor+veloc(itotv,1)*veloc(itotv,1)
        end do
        if(venor.gt.zero1) tstep=min(tstep,sizmi/sqrt(venor))
      end do
      tstep=min(safns*tstep,dtref)
      
      end
